"use strict";

function parseDate(dateStr) {
    let year = parseInt(dateStr.substring(0,4));
    let month = parseInt(dateStr.substring(4,6));
    let day = parseInt(dateStr.substring(6,8));

    return new Date(year, month, day, 0, 0, 0, 0);
}

// datagraft returns zero values as empty fields (i.e. "")
function maybeNull(valStr) {
    if (valStr === "") {
        return 0;
    }
    return valStr;
}

function onLineKeyword(base, lineVals) {

    // create keyword record
    let rec = {
        "Timestamp": parseDate(maybeNull(lineVals[0])),
        "Impressions": parseFloat(maybeNull(lineVals[3])),
        "WF_2d_avg": parseFloat(maybeNull(lineVals[4])),
        "WF_2d_min": parseFloat(maybeNull(lineVals[5])),
        "WF_2d_max": parseFloat(maybeNull(lineVals[6])),
        "WF_2t_avg": parseFloat(maybeNull(lineVals[7])),
        "WF_2t_min": parseFloat(maybeNull(lineVals[8])),
        "WF_2t_max": parseFloat(maybeNull(lineVals[9])),
        "WF_rh_avg": parseFloat(maybeNull(lineVals[10])),
        "WF_rh_min": parseFloat(maybeNull(lineVals[11])),
        "WF_rh_max": parseFloat(maybeNull(lineVals[12])),
        "WF_sd_avg": parseFloat(maybeNull(lineVals[13])),
        "WF_sd_min": parseFloat(maybeNull(lineVals[14])),
        "WF_sd_max": parseFloat(maybeNull(lineVals[15])),
        "WF_sp_avg": parseFloat(maybeNull(lineVals[16])),
        "WF_sp_min": parseFloat(maybeNull(lineVals[17])),
        "WF_sp_max": parseFloat(maybeNull(lineVals[18])),
        "WF_ssr_cumul": parseFloat(maybeNull(lineVals[19])),
        "WF_tcc_avg": parseFloat(maybeNull(lineVals[20])),
        "WF_tcc_min": parseFloat(maybeNull(lineVals[21])),
        "WF_tcc_max": parseFloat(maybeNull(lineVals[22])),
        "WF_tp_cumul": parseFloat(maybeNull(lineVals[23])),
        "WF_vis_avg": parseFloat(maybeNull(lineVals[24])),
        "WF_vis_min": parseFloat(maybeNull(lineVals[25])),
        "WF_vis_max": parseFloat(maybeNull(lineVals[26])),
        "WF_ws_avg": parseFloat(maybeNull(lineVals[27])),
        "WF_ws_min": parseFloat(maybeNull(lineVals[28])),
        "WF_ws_max": parseFloat(maybeNull(lineVals[29]))
    };

    base.store("Keywords").push(rec);
}


module.exports = { onLineKeyword };
