(ns grafterizer.transformation     (:require [grafter.tabular :refer :all]               [clojure.string :refer [capitalize lower-case upper-case trim trim-newline triml trimr]]               [tabular_functions.datatypes :as datatypes]               [tabular_functions.pipeline :as new-tabular]               [grafter.rdf :refer [prefixer s add]]               [grafter.rdf.templater :refer [graph]]			      [grafter.rdf.formats :refer :all]               [grafter.vocabularies.rdf :refer :all]               [grafter.vocabularies.qb :refer :all]               [grafter.vocabularies.sdmx-measure :refer :all]               [grafter.vocabularies.sdmx-attribute :refer :all]               [grafter.vocabularies.skos :refer :all]               [grafter.vocabularies.foaf :refer :all]               [grafter.vocabularies.owl :refer :all]          [grafter.vocabularies.dcterms :refer :all]			      [clj-time.format]			      [grafter.rdf.io :as ses]			      [grafter.tabular.common :refer [read-dataset*]]	)     (:import [gov.nasa.worldwind.geom.coords.UTMCoord]              [org.openrdf.model.impl.URIImpl]	)	)(def graph0 (prefixer "http://example.com/"))(def graph1 (prefixer "http://example.com/"))(defn double-literal [s] (if (nil? (re-matches (read-string "#\"[0-9.]+\"") s)) 0 (Double/parseDouble s)))(defn integer-literal [s] (if (nil? (re-matches (read-string "#\"[0-9.]+\"") s)) 0 (Integer/parseInt s)))(defn join [& strings] (clojure.string/join " " strings))(defn join-with [sep] (fn [& strings] (clojure.string/join sep strings)))(defn organize-date "Transform date dd/mm/yyyy ~> yyyy-mm-dd" [date] (when (seq date) (let [[d m y] (clojure.string/split date (read-string "#\"/\""))] (apply str (interpose "-" [y m d])))))(defn remove-blanks [s] (when (seq s) (clojure.string/replace s " " "")))(defn replace-varible-string [cell] (-> cell (clojure.string/replace (read-string "#\".* #\"") "number") (clojure.string/replace (read-string "#\"[0-9]{4} \"") "")))(def string-literal s)(defn stringToNumeric [x] (if (= "" x) nil (if (.contains x ".") (Double/parseDouble x) (Integer/parseInt x))))(defn titleize [st] (when (seq st) (let [a (clojure.string/split st (read-string "#\" \"")) c (map clojure.string/capitalize a)] (->> c (interpose " ") (apply str) clojure.string/trim))))(defn get-lat-long-strings-replacement [easting northing hemisphere zoneNumber] (let [utmCoords (. gov.nasa.worldwind.geom.coords.UTMCoord fromUTM (Integer/parseInt zoneNumber) (if (= hemisphere "N") "gov.nasa.worldwind.avkey.North" (if (= hemisphere "S") "gov.nasa.worldwind.avkey.East" (throw (Exception. "Wrong hemisphere input")))) (Double/parseDouble easting) (Double/parseDouble northing))] (vector (re-pattern easting) (str (.getDegrees (.getLongitude utmCoords))) (re-pattern northing) (str (.getDegrees (.getLatitude utmCoords))))))(defn replace-several [content replacements] (let [replacement-list (partition 2 replacements)] (reduce (fn [arg1 arg2] (apply clojure.string/replace arg1 arg2)) content replacement-list)))(defn convert-col-lat-long [col hemisphere zoneNumber] (let [all-coords (re-seq (re-pattern "-?[0-9.]+?(?=[, )])") col)] (replace-several col (flatten (map (fn [coord-pair] (get-lat-long-strings-replacement (nth coord-pair 0) (nth coord-pair 1) hemisphere zoneNumber)) (partition 2 all-coords))))))(def not-empty? (complement empty?))(defn enrich3togeoId1559467591747 "Enrichment - StrCity to geoId}" [v] (get {"Kirchheim unter Teck" "6557942" "Herrenberg" "6557935" "Baden-Baden" "6555605" "Aalen" "6558032" "Hockenheim" "6558054" "Stuttgart" "6690189" "Ludwigsburg" "6557960" "Pforzheim" "6547441" "Ubstadt-Weiher" "6555615" "Lahr" "6559326" "Oberkirch" "6558110" "Karlsruhe" "6555606" "Friedrichshafen" "6558180" "Leonberg" "6557937" "Waldshut-Tiengen" "6558152" "Wertheim am Main" "6558018" "Eberbach" "6558051" "Leimen" "6558056" "Karlsdorf-Neuthard" "6555619" "Heilbronn" "6555511" "Teningen" "6555772" "Sigmaringen" "6558200" "Gottmadingen" "6555863" "Vaihingen an der Enz" "6557965" "Bietigheim-Bissingen" "6557967" "Fellbach" "6557970" "Sankt Georgen im Schwarzwald" "6558128" "Bad Mergentheim" "6558009" "Hardheim" "6555643" "Deizisau" "6555415" "Bad Wurzach" "6558187" "Rastatt" "6558045" "Neustadt an der Donau" "6558133" "Kehl" "6558108" "Mannheim" "6559162" "Radolfzell" "6558138" "Konstanz" "6559164" "Oberkochen" "6558030" "Peiting" "6558829" "Berlin" "6547539" "Lauda-Konigshofen" "6558019" "Stutensee" "2825311" "Mulfingen" "6555541" "Nagold" "6558072" "Weinheim" "6558066" "Parkstein" "6558571" "Balingen" "6558162" "Schorndorf" "6557972" "Wehr" "6557323" "Waiblingen" "6557973" "Straubenhardt" "3209433" "Winnenden" "6557975" "Breisach" "6558087" "Ravensburg" "6558190" "Schwetzingen" "6558062" "Achern" "6558102" "Singen" "6559165" "Backnang" "6557969" "Renchen" "6558113" "Biberach" "6555780" "Sindelfingen" "6557939" "Offenburg" "6558111" "Villingen-Schwenningen" "6558130" "Weinstadt" "2812146" "Rheinstetten" "2847602" "Alfdorf" "6555494" "Reutlingen" "6558157" "Stockach" "6558139" "Heddesheim" "6555663" "Sinsheim" "6558063" "Markdorf" "6558181" "Gerstetten" "6555568" "Untergruppenbach" "6555535" "Tuttlingen" "6558136" "Ostfildern" "2856307" "Hechingen" "6558166" "Wiesloch" "6558067" "Bruchsal" "6558034" "Filderstadt" "2926870" "Weilheim an der Teck" "6557946" "Leutkirch im Allgau" "6558189" "Brackenheim" "6557979" "Schramberg" "6558120" "Bad Rappenau" "6557976" "Eberhardzell" "6558512" "Titisee-Neustadt" "6558094" "Bad Krozingen" "6555730" "Kusterdingen" "6555942" "Riedlingen" "6558179" "Schwaigern" "6557989" "Bad Friedrichshall" "2953457" "Heidelberg" "6555638" "Ettlingen" "6558035" "Schopfheim" "6558144" "Ilsfeld" "6555519" "Philippsburg" "6558037" "Burladingen" "6558163" "Deggendorf" "6558236" "Dettenheim" "2937917" "Eppelheim" "6558052" "Rehau" "6558315" "Haslach im Kinzigtal" "6558105" "Geisingen" "6558132" "Rottweil" "6558118" "Isny im Allgau" "6558188" "Sachsenheim" "2842513" "Mosbach" "6558048" "Waldkirch" "6558101" "Besigheim" "6557955" "Olching" "6556231" "Furtwangen" "6558126" "Wangen im Allgau" "6558191" "Wurzburg" "6556942" "Bretten" "6558033" "Crailsheim" "6558000" "Pfullingen" "6558156" "Neckarsulm" "6557986" "Blumberg" "6558123" "Calw" "6558077" "Walldorf" "6558065" "Furth im Wald" "6558260" "Remseck" "2848267" "Ostrach" "6556089" "Karlsbad" "3209432" "Dettelbach" "6558380" "Bietigheim" "6557967" "Forchheim" "6558309" "Laupheim" "6558177" "Dornstadt" "6558506" "Eningen" "6555925" "Eggenstein-Leopoldshafen" "6555618" "Ditzingen" "6550574" "Herbrechtingen" "6558022" "Aitrach" "6556054" "Korntal-Munchingen" "6557968" "Alzenau" "6558991" "Holzgerlingen" "6557936" "Coburg" "6556727" "Regensburg" "6556611" "Hallstadt" "6558294" "Albstadt" "6558170" "Weil am Rhein" "6558146" "Pfullendorf" "6558197" "Zirndorf" "6558354" "Dettingen an der Erms" "6555924" "Kandern" "6558141" "Kaufbeuren" "6557108" "Malsch" "6555612" "Waldbronn" "3209431" "Geislingen" "6558164" "Waakirchen" "6556282" "Horb am Neckar" "6558086" "Ellwangen" "6558025" "Donaueschingen" "6558125" "Bad Liebenzell" "6558069" "Grenzach-Wyhlen" "6555903" "Neresheim" "6558029" "Gaggenau" "6558041" "Konigs Wusterhausen" "6550590" "Tauberbischofsheim" "6558016" "Leinfelden-Echterdingen" "6557948" "Steinheim am Albuch" "6555573" "Bamberg" "6556725" "Rottenburg" "6559218" "Asperg" "6557954" "Poing" "6556158" "Hornberg" "6558107" "Bad Urach" "6558159" "Abensberg" "6558242" "Niedereschach" "6555825" "Weil der Stadt" "6555405" "Aschaffenburg" "6556940" "Bayreuth" "6556726" "Ispringen" "6555704" "Ulm" "6558415" "Haigerloch" "6558165" "Freudenstadt" "6558085" "Schwedt" "6559248" "Steinheim an der Murr" "6557964" "Welzheim" "6557974" "Garching" "6559193" "Erding" "6558215" "Ebersbach an der Fils" "6557950"} v ""))(defn enrich4togeoId_parentADM11559467615152 "Enrichment - geoId to geoId_parentADM1}" [v] (get {"2812146" "2953481" "2825311" "2953481" "2842513" "2953481" "2847602" "2953481" "2848267" "2953481" "2856307" "2953481" "2926870" "2953481" "2937917" "2953481" "2953457" "2953481" "3209431" "2953481" "3209432" "2953481" "3209433" "2953481" "6547441" "2953481" "6547539" "2950157" "6550574" "2953481" "6550590" "2945356" "6555405" "2953481" "6555415" "2953481" "6555494" "2953481" "6555511" "2953481" "6555519" "2953481" "6555535" "2953481" "6555541" "2953481" "6555568" "2953481" "6555573" "2953481" "6555605" "2953481" "6555606" "2953481" "6555612" "2953481" "6555615" "2953481" "6555618" "2953481" "6555619" "2953481" "6555638" "2953481" "6555643" "2953481" "6555663" "2953481" "6555704" "2953481" "6555730" "2953481" "6555772" "2953481" "6555780" "2953481" "6555825" "2953481" "6555863" "2953481" "6555903" "2953481" "6555924" "2953481" "6555925" "2953481" "6555942" "2953481" "6556054" "2953481" "6556089" "2953481" "6556158" "2951839" "6556231" "2951839" "6556282" "2951839" "6556611" "2951839" "6556725" "2951839" "6556726" "2951839" "6556727" "2951839" "6556940" "2951839" "6556942" "2951839" "6557108" "2951839" "6557323" "2953481" "6557935" "2953481" "6557936" "2953481" "6557937" "2953481" "6557939" "2953481" "6557942" "2953481" "6557946" "2953481" "6557948" "2953481" "6557950" "2953481" "6557954" "2953481" "6557955" "2953481" "6557960" "2953481" "6557964" "2953481" "6557965" "2953481" "6557967" "2953481" "6557968" "2953481" "6557969" "2953481" "6557970" "2953481" "6557972" "2953481" "6557973" "2953481" "6557974" "2953481" "6557975" "2953481" "6557976" "2953481" "6557979" "2953481" "6557986" "2953481" "6557989" "2953481" "6558000" "2953481" "6558009" "2953481" "6558016" "2953481" "6558018" "2953481" "6558019" "2953481" "6558022" "2953481" "6558025" "2953481" "6558029" "2953481" "6558030" "2953481" "6558032" "2953481" "6558033" "2953481" "6558034" "2953481" "6558035" "2953481" "6558037" "2953481" "6558041" "2953481" "6558045" "2953481" "6558048" "2953481" "6558051" "2953481" "6558052" "2953481" "6558054" "2953481" "6558056" "2953481" "6558062" "2953481" "6558063" "2953481" "6558065" "2953481" "6558066" "2953481" "6558067" "2953481" "6558069" "2953481" "6558072" "2953481" "6558077" "2953481" "6558085" "2953481" "6558086" "2953481" "6558087" "2953481" "6558094" "2953481" "6558101" "2953481" "6558102" "2953481" "6558105" "2953481" "6558107" "2953481" "6558108" "2953481" "6558110" "2953481" "6558111" "2953481" "6558113" "2953481" "6558118" "2953481" "6558120" "2953481" "6558123" "2953481" "6558125" "2953481" "6558126" "2953481" "6558128" "2953481" "6558130" "2953481" "6558132" "2953481" "6558133" "2953481" "6558136" "2953481" "6558138" "2953481" "6558139" "2953481" "6558141" "2953481" "6558144" "2953481" "6558146" "2953481" "6558152" "2953481" "6558156" "2953481" "6558157" "2953481" "6558159" "2953481" "6558162" "2953481" "6558163" "2953481" "6558164" "2953481" "6558165" "2953481" "6558166" "2953481" "6558170" "2953481" "6558177" "2953481" "6558179" "2953481" "6558180" "2953481" "6558181" "2953481" "6558187" "2953481" "6558188" "2953481" "6558189" "2953481" "6558190" "2953481" "6558191" "2953481" "6558197" "2953481" "6558200" "2953481" "6558215" "2951839" "6558236" "2951839" "6558242" "2951839" "6558260" "2951839" "6558294" "2951839" "6558309" "2951839" "6558315" "2951839" "6558354" "2951839" "6558380" "2951839" "6558415" "2951839" "6558506" "2953481" "6558512" "2953481" "6558571" "2951839" "6558829" "2951839" "6558991" "2951839" "6559162" "2953481" "6559164" "2953481" "6559165" "2953481" "6559193" "2951839" "6559218" "2951839" "6559248" "2945356" "6559326" "2953481" "6690189" "2953481"} v ""))(defn enrich0toWF_2d_2953481_+0_avg1559467755354 "Enrichment - Date to WF_2d_2953481_+0_avg}" [v] (get {"20170101" "277.0697942296143" "20170102" "272.5752186520571" "20170103" "276.522283755" "20170104" "270.82839807287144" "20170105" "264.6252209772286" "20170106" "264.69804772049997" "20170107" "274.1049739072428" "20170108" "274.0151261499" "20170109" "275.58827427454287" "20170110" "274.7156869026857" "20170111" "275.04970126682855" "20170112" "273.36111921391426" "20170113" "273.1396290612715" "20170114" "271.915878406" "20170115" "269.9692319399286" "20170116" "268.60436186025714" "20170117" "270.09042756934286" "20170118" "273.9718595122" "20170119" "277.0243316474143" "20170120" "276.6291764164143" "20170121" "276.16228288044283" "20170122" "274.07057870312855" "20170123" "273.70809830834287" "20170124" "275.3985741025" "20170126" "272.4778825724286" "20170127" "271.78349722549996" "20170128" "272.56459131282855" "20170129" "275.1658764904" "20170130" "275.1105341835715" "20170131" "274.1760701321286" "20170201" "273.3431997147857" "20170202" "274.2241263781857" "20170203" "275.4699513268857" "20170204" "276.0232426807143" "20170205" "274.81499530744287" "20170206" "272.47581105417146" "20170207" "270.1225194889715" "20170208" "267.6520379577" "20170209" "266.99496499592857" "20170210" "269.48816006041426" "20170211" "269.93974200714285" "20170212" "270.56339095474283" "20170214" "270.7156483924" "20170215" "272.8244715438714" "20170217" "276.7623053216143" "20170218" "275.89185803347146" "20170219" "277.0436664267286" "20170220" "278.0795253737143" "20170221" "275.7515673616571" "20170222" "275.7427529339" "20170223" "275.3351554045" "20170227" "277.6803128241143" "20170302" "275.07566774047143" "20170304" "276.17240097685715" "20170305" "276.5299398138714" "20170306" "273.94667588271426" "20170307" "269.90997094268573" "20170310" "275.8178108512715" "20170312" "273.7667032437429" "20170315" "275.7090400376714" "20170318" "274.7837766617" "20170319" "275.8481343147001" "20170320" "278.52474451545714" "20170323" "275.18269962459993" "20170331" "280.28090263685715" "20170402" "279.2093056682857" "20170403" "277.3227866697143" "20170405" "276.8923075622429" "20170412" "278.82309774644284" "20170415" "276.86906452924285" "20170416" "273.9703945143429" "20170417" "273.77684067235714" "20170418" "270.6145928453" "20170419" "269.80743610774283" "20170421" "278.8567848370714" "20170422" "274.6918554264428" "20170423" "273.6229746544714" "20170425" "271.9055119414" "20170426" "273.91965060762857" "20170427" "275.4184598496143" "20170429" "275.7644631301857" "20170430" "276.36298285590004" "20170501" "276.5280976619" "20170503" "276.17213111865715" "20170507" "279.52724686878577" "20170508" "274.93362510427147" "20170510" "277.5144694714857" "20170517" "284.4777927151" "20170522" "282.37920640557144" "20170605" "283.6008247936857" "20170606" "284.71188129902856" "20170607" "283.0317636465" "20170612" "284.3121772975286" "20170615" "286.0366785178571" "20170616" "284.6807713364143" "20170622" "286.81003322848574" "20170623" "287.12645180882856" "20170628" "285.0951933537571" "20170702" "284.41699024990004" "20170706" "283.1833009926" "20170707" "287.1880763550714" "20170708" "286.28127536525716" "20170709" "283.59595149318574" "20170710" "286.2107662844857" "20170711" "287.03570195537145" "20170712" "284.09300507164284" "20170713" "282.3788960334286" "20170714" "283.9378160088571" "20170716" "287.16472481511425" "20170717" "284.61665870478566" "20170718" "285.5656100626857" "20170719" "286.9193057105571" "20170721" "286.48129875768575" "20170723" "287.61414895327147" "20170729" "287.51545149457144" "20170808" "287.3847370890571" "20170811" "285.7054381707714" "20170813" "283.26132946371433" "20170814" "283.45218296242854" "20170815" "288.30075482784287" "20170817" "288.3475720514286" "20170819" "285.1269679214" "20170820" "285.338137584" "20170821" "284.82508645325714" "20170822" "284.15406330322855" "20170823" "285.1536342076" "20170825" "286.41698302780003" "20170827" "286.18919348338574" "20170828" "286.82885143285716" "20170829" "288.24966426261426" "20170907" "284.45370346884283" "20170909" "285.11669076367144" "20170910" "284.62631089071425" "20170911" "284.94325051578573" "20170912" "284.44402626994287" "20170914" "283.78835051121433" "20170915" "283.5388694421857" "20170917" "283.0846396442143" "20170923" "284.90124388414284" "20170924" "286.21910440904287" "20170925" "285.91829039558576" "20170928" "285.5386182556572" "20170929" "286.2969581416857" "20170930" "284.8835026464429" "20171001" "283.87612029898577" "20171003" "283.0055993811" "20171004" "282.0469909051286" "20171005" "281.02885016458566" "20171008" "278.56200361595717" "20171009" "280.05348194555717" "20171011" "285.2409481252429" "20171012" "282.1166174862571" "20171013" "284.5048570949571" "20171014" "287.1193305121714" "20171015" "286.6943366421" "20171016" "286.65000274791424" "20171017" "283.7518692787286" "20171018" "283.98917150015717" "20171019" "284.91585744441426" "20171020" "285.0439312206857" "20171021" "283.9546409265714" "20171022" "282.5616245462571" "20171023" "282.2731218434429" "20171024" "283.87551646488566" "20171025" "284.4130260472857" "20171026" "282.55727440418565" "20171027" "280.55539772727144" "20171028" "281.53200391188574" "20171029" "276.6028818458143" "20171030" "274.17887087954284" "20171031" "279.7531465692857" "20171101" "284.060867816" "20171103" "279.8838020974143" "20171104" "281.4549453096714" "20171105" "279.71988720915715" "20171106" "276.7318895568429" "20171109" "279.4035986257571" "20171111" "275.51181492660004" "20171112" "277.1169623833286" "20171113" "275.23425592418573" "20171115" "279.8577552344" "20171116" "280.34348742991426" "20171117" "276.97327135754284" "20171118" "277.2506651334857" "20171119" "275.689258658" "20171120" "274.7420694810714" "20171121" "277.36390657411425" "20171122" "281.4035552934571" "20171123" "278.91980491295715" "20171124" "277.09161861359996" "20171125" "275.4156404305286" "20171126" "276.71633536819996" "20171127" "277.26532096917146" "20171128" "276.55591947655716" "20171129" "274.8688337758" "20171130" "274.51426654941423" "20171201" "273.7131234041" "20171202" "275.0784842530857" "20171203" "276.8721082503" "20171204" "275.50348527915713" "20171205" "279.21987840177144" "20171206" "279.5997453609572" "20171207" "277.8458309641571" "20171208" "274.7394818722714" "20171210" "272.8976620981" "20171211" "272.5160636076143" "20171212" "273.5465079083286" "20171213" "275.2923021633" "20171214" "275.1427623754" "20171215" "275.2047173746286" "20171216" "273.56885034251434" "20171217" "272.73512292285716" "20171219" "277.4278557627428" "20171220" "279.0413841258571" "20171222" "277.30761824437144" "20171223" "279.77855846411427" "20171224" "280.00836595585713" "20171225" "279.1243049214286" "20171226" "276.1864751730428" "20171227" "275.6862215204286" "20171228" "275.4178739825571" "20171229" "274.49051863324286" "20171230" "275.26078340605716" "20171231" "278.38445454827144"} v ""))(defn enrich0toWF_2d_2953481_+0_min1559467755354 "Enrichment - Date to WF_2d_2953481_+0_min}" [v] (get {"20170101" "274.9700696541" "20170102" "270.8380543102" "20170103" "273.6178286774" "20170104" "267.3569952454" "20170105" "262.7988632665" "20170106" "262.9478781344" "20170107" "269.0531603881" "20170108" "273.0150578046" "20170109" "275.259250217" "20170110" "274.4364251031" "20170111" "274.396706321" "20170112" "272.9171894729" "20170113" "272.6639391967" "20170114" "271.3229684541" "20170115" "268.8827875311" "20170116" "267.9994032118" "20170117" "268.891068892" "20170118" "272.334312516" "20170119" "275.6478026419" "20170120" "276.4879850137" "20170121" "275.7587505302" "20170122" "272.8012502651" "20170123" "272.5818159315" "20170124" "274.663624619" "20170126" "271.5918150622" "20170127" "271.38307976" "20170128" "272.0634844231" "20170129" "272.5522140349" "20170130" "274.6890684186" "20170131" "273.2191593671" "20170201" "273.1578776042" "20170202" "273.2403034249" "20170203" "275.1095155658" "20170204" "275.5635431463" "20170205" "273.9190957426" "20170206" "271.0554322522" "20170207" "269.0110701744" "20170208" "267.2369397096" "20170209" "266.3297328756" "20170210" "267.9543111782" "20170211" "269.532317807" "20170212" "270.1312712082" "20170214" "270.2264046717" "20170215" "271.7141620366" "20170217" "276.5310749092" "20170218" "275.7375315657" "20170219" "276.2045824455" "20170220" "277.1882126933" "20170221" "275.4250488281" "20170222" "274.3557079585" "20170223" "274.4170563052" "20170227" "277.0499156605" "20170302" "274.7310606061" "20170304" "275.128869259" "20170305" "275.9024571891" "20170306" "272.0066139915" "20170307" "269.3049784959" "20170310" "275.1779686514" "20170312" "273.4303360756" "20170315" "274.7045577849" "20170318" "273.3316860006" "20170319" "273.936429727" "20170320" "277.7735016177" "20170323" "274.0428799716" "20170331" "279.2669714725" "20170402" "278.7672008168" "20170403" "276.7461332071" "20170405" "275.8434651693" "20170412" "277.5712767322" "20170415" "275.2873115925" "20170416" "273.1713694563" "20170417" "272.8227834991" "20170418" "269.2093764796" "20170419" "268.5970397333" "20170421" "275.4487230705" "20170422" "274.0417825718" "20170423" "272.2962535511" "20170425" "271.2483230745" "20170426" "273.0513533775" "20170427" "274.2067303898" "20170429" "275.0831853693" "20170430" "276.15838808" "20170501" "276.0093735204" "20170503" "275.0352277659" "20170507" "278.9886634904" "20170508" "273.1962570036" "20170510" "277.0574420967" "20170517" "283.4336973248" "20170522" "282.1513819839" "20170605" "283.1349037247" "20170606" "283.8081005366" "20170607" "282.6046796086" "20170612" "283.5916242503" "20170615" "285.405993529" "20170616" "284.0903406625" "20170622" "284.1676333649" "20170623" "286.375515408" "20170628" "283.266655816" "20170702" "283.0912321457" "20170706" "282.4522742069" "20170707" "285.194649128" "20170708" "283.4606267756" "20170709" "282.1704348169" "20170710" "285.5769240254" "20170711" "285.9544098209" "20170712" "282.7383281053" "20170713" "281.8294221512" "20170714" "283.426296658" "20170716" "285.7338521938" "20170717" "283.7828085543" "20170718" "284.9237097538" "20170719" "286.1203983191" "20170721" "285.410082268" "20170723" "286.2960710622" "20170729" "286.9079713147" "20170808" "286.9427527225" "20170811" "285.246056759" "20170813" "282.2313466698" "20170814" "282.5778118095" "20170815" "286.6946441959" "20170817" "286.6465484927" "20170819" "284.7178104285" "20170820" "285.1470712989" "20170821" "283.9146839489" "20170822" "283.2806285511" "20170823" "284.622824929" "20170825" "286.0193882181" "20170827" "285.738796658" "20170828" "286.2966308594" "20170829" "287.4642691564" "20170907" "284.0300194326" "20170909" "284.6465016375" "20170910" "284.2787543403" "20170911" "284.7999477194" "20170912" "284.1610070431" "20170914" "283.3694661458" "20170915" "283.4285013218" "20170917" "282.8349116162" "20170923" "284.5448158341" "20170924" "285.487210977" "20170925" "285.3720653804" "20170928" "285.0870940854" "20170929" "285.9735440341" "20170930" "284.109927399" "20171001" "283.4423482876" "20171003" "282.1545878709" "20171004" "280.5976463857" "20171005" "280.5345643939" "20171008" "277.4907793758" "20171009" "278.7715928819" "20171011" "284.318137429" "20171012" "280.7454920297" "20171013" "282.0431808318" "20171014" "286.9118726326" "20171015" "286.4348637745" "20171016" "286.2048241201" "20171017" "282.5864085188" "20171018" "283.3286724669" "20171019" "284.4641483191" "20171020" "284.5689265704" "20171021" "283.6904173572" "20171022" "282.069612137" "20171023" "281.7661453401" "20171024" "281.854583432" "20171025" "282.6360331834" "20171026" "282.0688501223" "20171027" "279.4283706203" "20171028" "280.3353012547" "20171029" "274.5599648832" "20171030" "273.4516404277" "20171031" "275.849979285" "20171101" "283.042085898" "20171103" "279.0216175426" "20171104" "280.8247390901" "20171105" "278.1585311119" "20171106" "276.0747834793" "20171109" "277.998340337" "20171111" "274.619436553" "20171112" "275.8072226168" "20171113" "274.3947778567" "20171115" "278.8583879567" "20171116" "278.5841397372" "20171117" "276.4538598879" "20171118" "276.0017213147" "20171119" "274.1710020123" "20171120" "274.116341639" "20171121" "276.5688180634" "20171122" "279.3283296836" "20171123" "278.3386773003" "20171124" "275.9220550229" "20171125" "274.9881752091" "20171126" "275.0022539852" "20171127" "276.9651544744" "20171128" "276.0034031723" "20171129" "273.5865096275" "20171130" "274.1744791667" "20171201" "272.3004890211" "20171202" "272.5099222202" "20171203" "275.680693347" "20171204" "274.5257013494" "20171205" "278.2593513258" "20171206" "278.9824120107" "20171207" "277.341041642" "20171208" "273.4818374171" "20171210" "272.1197596078" "20171211" "271.5700806897" "20171212" "272.4896351207" "20171213" "274.5858832465" "20171214" "274.7481109927" "20171215" "274.1167756668" "20171216" "272.3235874369" "20171217" "271.8663835622" "20171219" "276.6790638933" "20171220" "277.6453499842" "20171222" "276.6541661735" "20171223" "278.265144117" "20171224" "279.7282788826" "20171225" "278.3791701192" "20171226" "275.3986002604" "20171227" "275.3298068576" "20171228" "275.2030781447" "20171229" "273.7274054325" "20171230" "273.5041701192" "20171231" "276.1925455729"} v ""))(defn enrich0toWF_2d_2953481_+0_max1559467755354 "Enrichment - Date to WF_2d_2953481_+0_max}" [v] (get {"20170101" "278.8662786002" "20170102" "275.1623023447" "20170103" "278.3788412075" "20170104" "273.2406979956" "20170105" "267.9516798848" "20170106" "267.0811251245" "20170107" "276.3418945929" "20170108" "275.0511930832" "20170109" "275.9613692158" "20170110" "275.2870375508" "20170111" "275.8275863185" "20170112" "274.4133103496" "20170113" "273.6603140783" "20170114" "273.0004192314" "20170115" "271.180479724" "20170116" "269.3733739371" "20170117" "271.6225844875" "20170118" "275.4958562369" "20170119" "277.8082295427" "20170120" "276.7768802835" "20170121" "276.4464034264" "20170122" "275.8708144679" "20170123" "274.5507308498" "20170124" "275.7757542157" "20170126" "272.8823649089" "20170127" "272.1601112443" "20170128" "272.9692826705" "20170129" "276.0514588019" "20170130" "275.8137805052" "20170131" "275.106940992" "20170201" "273.522480666" "20170202" "274.8824475221" "20170203" "275.730024858" "20170204" "276.3378092448" "20170205" "275.6059200402" "20170206" "273.7276894926" "20170207" "270.9854995265" "20170208" "268.7102765941" "20170209" "267.660930595" "20170210" "270.7188880997" "20170211" "270.4217516967" "20170212" "270.8718754932" "20170214" "271.2076921559" "20170215" "273.8844869594" "20170217" "277.0430698587" "20170218" "276.3761689157" "20170219" "277.4519289575" "20170220" "278.6375029593" "20170221" "276.8822674992" "20170222" "278.0439354482" "20170223" "275.8167441012" "20170227" "278.0448380287" "20170302" "275.4070342093" "20170304" "276.9519634825" "20170305" "276.9804169626" "20170306" "275.6684545652" "20170307" "271.7501331676" "20170310" "276.3630568379" "20170312" "274.3548349708" "20170315" "276.6275573114" "20170318" "276.7636866714" "20170319" "277.6589478772" "20170320" "279.1792337437" "20170323" "276.1001099866" "20170331" "281.0676713423" "20170402" "279.4564369279" "20170403" "278.5543151239" "20170405" "277.8664008247" "20170412" "279.5716787011" "20170415" "278.2049326271" "20170416" "275.1429209083" "20170417" "274.2449963502" "20170418" "272.9575762508" "20170419" "271.37131323" "20170421" "280.0174202967" "20170422" "275.2997898911" "20170423" "274.9001366201" "20170425" "273.099056976" "20170426" "275.0095757378" "20170427" "277.0268036813" "20170429" "276.6507827296" "20170430" "276.6925209122" "20170501" "276.9714429451" "20170503" "276.9086642795" "20170507" "279.9039688881" "20170508" "278.9783849235" "20170510" "278.3213408499" "20170517" "285.3804943971" "20170522" "282.6230666035" "20170605" "283.9384321733" "20170606" "285.3394713739" "20170607" "283.3769383286" "20170612" "286.6065488873" "20170615" "286.4607796717" "20170616" "285.8702799479" "20170622" "288.2111520478" "20170623" "287.8674612334" "20170628" "285.8681640625" "20170702" "285.4662617385" "20170706" "284.5036645754" "20170707" "287.8373283617" "20170708" "287.9042549519" "20170709" "285.0887266217" "20170710" "286.7211371528" "20170711" "287.7167426215" "20170712" "285.9312682489" "20170713" "283.1189236111" "20170714" "284.6259469697" "20170716" "288.134139244" "20170717" "285.2269644689" "20170718" "286.1997366241" "20170719" "287.5624852036" "20170721" "289.0414249921" "20170723" "289.050374349" "20170729" "288.1425645616" "20170808" "287.8685931581" "20170811" "286.5059629498" "20170813" "285.6157818419" "20170814" "285.2110558712" "20170815" "288.8514120699" "20170817" "289.2024788905" "20170819" "286.45039753" "20170820" "285.4781728417" "20170821" "285.8267045455" "20170822" "285.198814315" "20170823" "285.5284707426" "20170825" "286.9349130958" "20170827" "287.0974170415" "20170828" "287.4039072364" "20170829" "288.928617227" "20170907" "284.7729467527" "20170909" "285.6322995581" "20170910" "285.0942925347" "20170911" "285.2812204072" "20170912" "284.7672920612" "20170914" "284.095335681" "20170915" "283.7164762863" "20170917" "283.4760939473" "20170923" "285.2429149897" "20170924" "286.5585912839" "20170925" "286.5710103969" "20170928" "286.0260515309" "20170929" "286.5603915128" "20170930" "285.3240658539" "20171001" "284.3252027107" "20171003" "283.8848963265" "20171004" "283.3919048887" "20171005" "281.5972024937" "20171008" "281.1209581163" "20171009" "281.2346092764" "20171011" "285.9161044034" "20171012" "284.7480740017" "20171013" "286.3118292298" "20171014" "287.2649936869" "20171015" "287.0474421954" "20171016" "286.9291400331" "20171017" "286.5220219776" "20171018" "284.3130450008" "20171019" "285.3326379025" "20171020" "285.3563466698" "20171021" "284.3662602588" "20171022" "283.5531733349" "20171023" "282.6585976957" "20171024" "285.9128639915" "20171025" "286.3092842487" "20171026" "282.8567609691" "20171027" "281.7169571693" "20171028" "282.2575338344" "20171029" "280.82657631" "20171030" "274.9567106613" "20171031" "283.1394560843" "20171101" "284.7242887863" "20171103" "280.8018638534" "20171104" "282.279333866" "20171105" "282.2950747711" "20171106" "278.6088127367" "20171109" "280.5527639678" "20171111" "275.9217763573" "20171112" "277.8014939433" "20171113" "276.4429056187" "20171115" "280.7081203268" "20171116" "281.4351128472" "20171117" "277.9563284209" "20171118" "278.6699835267" "20171119" "277.3838531802" "20171120" "275.6300455729" "20171121" "278.6186572759" "20171122" "282.7358398438" "20171123" "279.7120521622" "20171124" "278.0394126815" "20171125" "275.9179144965" "20171126" "277.609707919" "20171127" "277.602963226" "20171128" "277.3707287721" "20171129" "275.7450703322" "20171130" "274.8301915641" "20171201" "274.2112506905" "20171202" "277.1796628393" "20171203" "277.7356968119" "20171204" "276.9542766533" "20171205" "279.6838650174" "20171206" "279.880232994" "20171207" "279.2897727273" "20171208" "276.5396420257" "20171210" "273.3187430025" "20171211" "273.5773925781" "20171212" "275.0456395005" "20171213" "276.373157848" "20171214" "276.0730670967" "20171215" "275.7949514678" "20171216" "274.5775454743" "20171217" "274.0017558396" "20171219" "277.8703835227" "20171220" "280.1311774976" "20171222" "278.6008892637" "20171223" "280.3151954111" "20171224" "280.2175243647" "20171225" "279.896521366" "20171226" "277.6560921717" "20171227" "276.0615554964" "20171228" "275.7742389717" "20171229" "275.1600428109" "20171230" "276.1418432371" "20171231" "280.0073291509"} v ""))(defn enrich0toWF_2t_2953481_+0_avg1559467755354 "Enrichment - Date to WF_2t_2953481_+0_avg}" [v] (get {"20170101" "279.29831447847147" "20170102" "276.3650892293429" "20170103" "279.03218569624283" "20170104" "276.7016189377" "20170105" "270.9399436080857" "20170106" "271.07609489847147" "20170107" "276.4494186335286" "20170108" "275.81121905438573" "20170109" "276.9810835052572" "20170110" "276.80686228477146" "20170111" "277.69393929705717" "20170112" "277.35340218592853" "20170113" "275.8502857819" "20170114" "275.6903673312286" "20170115" "274.6969029590286" "20170116" "273.5317717493" "20170117" "274.4427401059857" "20170118" "276.5250659848857" "20170119" "278.0087794404143" "20170120" "277.98805597918573" "20170121" "277.48513443851425" "20170122" "275.8800455288857" "20170123" "276.04454731905713" "20170124" "276.85579882865716" "20170126" "274.3553570503857" "20170127" "274.7849952510714" "20170128" "275.6081465463572" "20170129" "277.0080531176714" "20170130" "276.2976232751571" "20170131" "276.1766267586857" "20170201" "275.42154807000003" "20170202" "275.9404402563572" "20170203" "276.4629258545286" "20170204" "276.9330269069143" "20170205" "276.0222802100143" "20170206" "275.2123875473286" "20170207" "273.7358838806571" "20170208" "272.1618666435571" "20170209" "271.57413243764285" "20170210" "272.7069593817714" "20170211" "273.3186708040143" "20170212" "273.46021036254285" "20170214" "273.9002852887285" "20170215" "275.6397016340857" "20170217" "277.7533136893571" "20170218" "276.9418818486286" "20170219" "277.98890269885715" "20170220" "279.1244303385428" "20170221" "278.44929378890004" "20170222" "278.8389887293714" "20170223" "277.1691161756857" "20170227" "279.8155332623" "20170302" "277.49411173677146" "20170304" "278.3197026768857" "20170305" "277.94404071405717" "20170306" "275.93109562421427" "20170307" "274.3980048814143" "20170310" "278.1750364978143" "20170312" "276.77217593062863" "20170315" "279.2302172111714" "20170318" "277.8375400911857" "20170319" "277.24506716157146" "20170320" "279.36952427454287" "20170323" "278.35282477395714" "20170331" "282.8656000575" "20170402" "280.69521456191427" "20170403" "279.4083021199714" "20170405" "280.1630834714571" "20170412" "280.65290988851433" "20170415" "279.31327293582854" "20170416" "278.14476165108573" "20170417" "278.2000413594714" "20170418" "277.0861576845286" "20170419" "277.36701980745715" "20170421" "281.22403513371427" "20170422" "279.69434122192854" "20170423" "279.31036720441426" "20170425" "278.1358330796857" "20170426" "278.68444102012853" "20170427" "279.2405887840428" "20170429" "279.4783014294714" "20170430" "280.4422531678286" "20170501" "281.1021899378857" "20170503" "282.02199555542853" "20170507" "282.21771566108566" "20170508" "280.8328492796143" "20170510" "280.51148623511426" "20170517" "286.45985560121426" "20170522" "285.2100708536429" "20170605" "287.2055766228286" "20170606" "288.4970706648" "20170607" "286.17803629205713" "20170612" "287.6148461456143" "20170615" "288.6499125603143" "20170616" "287.6420214984714" "20170622" "289.22178784215714" "20170623" "288.9373143403857" "20170628" "288.6562655009857" "20170702" "287.9699072899857" "20170706" "287.6812509864286" "20170707" "289.3581525354" "20170708" "289.0211222154572" "20170709" "288.4579898454571" "20170710" "289.06991757699996" "20170711" "289.4551778245714" "20170712" "287.9208667309428" "20170713" "288.2231853975143" "20170714" "288.55483299795713" "20170716" "289.48859162212864" "20170717" "289.05789867142863" "20170718" "289.31197472775716" "20170719" "290.22548412417143" "20170721" "289.97849343039996" "20170723" "289.95692203845715" "20170729" "290.3699695757857" "20170808" "291.5468267355429" "20170811" "289.52055924762857" "20170813" "289.16750407251425" "20170814" "289.52334484634287" "20170815" "291.8771750710143" "20170817" "291.16800292264287" "20170819" "289.2405257231714" "20170820" "288.99942575871427" "20170821" "289.28604473868575" "20170822" "289.1740912895857" "20170823" "289.5992764559714" "20170825" "290.2351422991143" "20170827" "289.6983256814714" "20170828" "289.9678653865714" "20170829" "291.64123024328575" "20170907" "288.64406023122854" "20170909" "288.3318297371" "20170910" "288.75352894177144" "20170911" "288.50108683092856" "20170912" "288.2498513314" "20170914" "286.8256490688143" "20170915" "286.84714753562855" "20170917" "286.16101197521425" "20170923" "287.4025984594857" "20170924" "288.2860334652429" "20170925" "288.38057401581426" "20170928" "288.2943155748286" "20170929" "288.68645685369995" "20170930" "287.7967291497429" "20171001" "287.57649246370005" "20171003" "286.7293421097285" "20171004" "286.11161031352856" "20171005" "285.08793149124284" "20171008" "284.2772606082857" "20171009" "284.6586773144286" "20171011" "287.42728977838567" "20171012" "286.2679878444143" "20171013" "287.13749239041425" "20171014" "288.38473039547137" "20171015" "288.2442350401428" "20171016" "288.1426771199714" "20171017" "287.684241621" "20171018" "286.364287053" "20171019" "286.439863549" "20171020" "286.7475374560143" "20171021" "285.92790418132853" "20171022" "285.0629551654857" "20171023" "284.7833933644428" "20171024" "285.83859486325713" "20171025" "286.81971888245715" "20171026" "285.9654870411572" "20171027" "284.68236741014283" "20171028" "285.2356094426286" "20171029" "283.11227016255714" "20171030" "281.59332654108573" "20171031" "283.7096403488143" "20171101" "285.79996286808574" "20171103" "283.6137476889572" "20171104" "283.8929941857143" "20171105" "283.3372445154714" "20171106" "281.6716414282143" "20171109" "282.8461188334143" "20171111" "280.2876395793857" "20171112" "280.6411058830714" "20171113" "279.8165246212142" "20171115" "282.3291244616857" "20171116" "282.3441607762857" "20171117" "281.67316193464285" "20171118" "280.6462589060143" "20171119" "279.6740814253143" "20171120" "279.1422050443143" "20171121" "279.7807677077714" "20171122" "283.38609131208574" "20171123" "283.5841326913286" "20171124" "281.1517684518" "20171125" "279.17198667761426" "20171126" "279.76542912384286" "20171127" "279.8208913211429" "20171128" "279.3928701777857" "20171129" "277.3936515687" "20171130" "276.95012273968575" "20171201" "276.89117669440003" "20171202" "278.3363765920143" "20171203" "279.8581708987857" "20171204" "279.2610201484714" "20171205" "281.60387989831435" "20171206" "281.94846237204285" "20171207" "280.77884382328574" "20171208" "278.55574579501433" "20171210" "275.7754489078429" "20171211" "275.76863113557135" "20171212" "277.15702117437144" "20171213" "277.60865385157143" "20171214" "277.82890709551424" "20171215" "277.7075015641857" "20171216" "276.75433922087143" "20171217" "276.3265062032286" "20171219" "278.8658720294428" "20171220" "279.7966597475857" "20171222" "279.38792571360005" "20171223" "281.22838809412855" "20171224" "281.7124981680857" "20171225" "281.1254298002286" "20171226" "278.87724482547145" "20171227" "278.1340215774" "20171228" "278.12986731151426" "20171229" "277.37112087674285" "20171230" "277.23417278249997" "20171231" "280.01972184174286"} v ""))(defn enrich0toWF_2t_2953481_+0_min1559467755355 "Enrichment - Date to WF_2t_2953481_+0_min}" [v] (get {"20170101" "278.2773585464" "20170102" "275.6419098209" "20170103" "276.7153024384" "20170104" "274.1669157394" "20170105" "269.742905742" "20170106" "269.6611476089" "20170107" "273.2828047011" "20170108" "274.8811947601" "20170109" "276.6674311474" "20170110" "276.3586080532" "20170111" "277.0470132539" "20170112" "276.3091165562" "20170113" "275.4925352154" "20170114" "275.3427709714" "20170115" "273.6186427877" "20170116" "272.8714430067" "20170117" "273.192915483" "20170118" "276.0074657093" "20170119" "277.1698153717" "20170120" "277.738487629" "20170121" "276.9525430082" "20170122" "274.9796278212" "20170123" "274.9551243638" "20170124" "276.3953832761" "20170126" "273.4794625947" "20170127" "273.8117009943" "20170128" "274.9603086529" "20170129" "274.8948715672" "20170130" "275.901275943" "20170131" "275.5394866635" "20170201" "275.2168215357" "20170202" "274.938607264" "20170203" "276.0730547664" "20170204" "276.2534771544" "20170205" "275.7112408262" "20170206" "274.4822517164" "20170207" "273.0051491477" "20170208" "271.6079150884" "20170209" "271.131670711" "20170210" "271.6787627249" "20170211" "272.6370368726" "20170212" "273.1113725142" "20170214" "272.0461327139" "20170215" "273.9207455414" "20170217" "277.3242680713" "20170218" "276.244360105" "20170219" "277.2668925584" "20170220" "277.9837806779" "20170221" "277.2662489149" "20170222" "278.1675692472" "20170223" "276.1646494239" "20170227" "279.6078361742" "20170302" "276.683300288" "20170304" "277.2276253748" "20170305" "277.2578198982" "20170306" "274.8423936632" "20170307" "273.7965593434" "20170310" "276.8276342527" "20170312" "275.7787469421" "20170315" "278.061395202" "20170318" "277.1191356929" "20170319" "275.8439275568" "20170320" "278.2442836569" "20170323" "277.0146385732" "20170331" "281.5807069721" "20170402" "279.8338684699" "20170403" "278.2137192235" "20170405" "279.4395197088" "20170412" "280.0215830177" "20170415" "278.0158518782" "20170416" "276.7950303819" "20170417" "277.4051131432" "20170418" "276.0107471196" "20170419" "275.953970861" "20170421" "279.5391907355" "20170422" "278.3798384233" "20170423" "278.4147184738" "20170425" "277.0317136206" "20170426" "277.1300973603" "20170427" "277.7391073824" "20170429" "278.4984118529" "20170430" "278.7379828559" "20170501" "280.1486693103" "20170503" "281.251585681" "20170507" "280.8439472854" "20170508" "279.5828993056" "20170510" "279.9149552162" "20170517" "284.6650686553" "20170522" "283.2833362926" "20170605" "285.5553558041" "20170606" "287.1819858744" "20170607" "285.8996310764" "20170612" "286.8852045849" "20170615" "286.648659446" "20170616" "286.7232407079" "20170622" "287.1586420849" "20170623" "288.5688575205" "20170628" "286.8343937421" "20170702" "287.2560196693" "20170706" "285.9958619397" "20170707" "288.0822753906" "20170708" "287.458394985" "20170709" "286.8345910275" "20170710" "287.6249186198" "20170711" "288.4291424992" "20170712" "287.327794547" "20170713" "287.00390625" "20170714" "287.18477253" "20170716" "288.5303622159" "20170717" "287.5521918403" "20170718" "288.12868677" "20170719" "287.8766621291" "20170721" "289.0408084754" "20170723" "289.0011565854" "20170729" "289.5533212989" "20170808" "289.7035738242" "20170811" "288.4633098564" "20170813" "288.2651761758" "20170814" "287.8397031842" "20170815" "290.0176175821" "20170817" "289.8736633917" "20170819" "288.5431832978" "20170820" "288.2615411932" "20170821" "288.2280889954" "20170822" "288.0359453914" "20170823" "288.2486017401" "20170825" "289.3396834557" "20170827" "288.8051856455" "20170828" "288.5495753433" "20170829" "290.2040275805" "20170907" "288.0790645715" "20170909" "287.7735016177" "20170910" "287.6262774227" "20170911" "287.9367503157" "20170912" "287.6804741753" "20170914" "286.3596290049" "20170915" "286.2580837674" "20170917" "285.2907813486" "20170923" "286.0528502801" "20170924" "287.3652541035" "20170925" "287.646447384" "20170928" "287.7359779435" "20170929" "287.8008059107" "20170930" "287.3326255721" "20171001" "286.8606820155" "20171003" "286.3818458018" "20171004" "285.7168683909" "20171005" "284.2144689078" "20171008" "283.500922309" "20171009" "283.5323646622" "20171011" "286.567400075" "20171012" "285.8067022767" "20171013" "285.6953396267" "20171014" "288.0902210582" "20171015" "287.4253225616" "20171016" "287.2571614583" "20171017" "286.8479250513" "20171018" "285.969743825" "20171019" "285.7388015901" "20171020" "286.1994258996" "20171021" "285.3084605824" "20171022" "284.702942511" "20171023" "284.3915201823" "20171024" "284.6193477746" "20171025" "285.8455674913" "20171026" "285.2479334359" "20171027" "284.3813501223" "20171028" "284.7441159643" "20171029" "282.3021943063" "20171030" "280.6448666351" "20171031" "281.5291365807" "20171101" "285.0762014678" "20171103" "282.7828751381" "20171104" "283.6379567156" "20171105" "281.9081192787" "20171106" "281.0774418995" "20171109" "281.5276939315" "20171111" "279.6960449219" "20171112" "280.3654760496" "20171113" "279.4734182647" "20171115" "281.4283755524" "20171116" "281.0074771149" "20171117" "280.9548339844" "20171118" "280.3255159012" "20171119" "278.4019664418" "20171120" "278.7376030816" "20171121" "279.0865219579" "20171122" "281.0422807173" "20171123" "282.6457420889" "20171124" "279.9961430713" "20171125" "278.6022505327" "20171126" "278.8872785472" "20171127" "279.6908711135" "20171128" "278.5695085622" "20171129" "276.6656407828" "20171130" "276.5429243608" "20171201" "276.2222937382" "20171202" "276.0916341146" "20171203" "278.7787888652" "20171204" "278.702572601" "20171205" "280.3692935211" "20171206" "281.5764406763" "20171207" "280.0580561474" "20171208" "277.7972547743" "20171210" "275.1061617148" "20171211" "274.7545005721" "20171212" "276.3329806858" "20171213" "277.0826132418" "20171214" "277.4788164852" "20171215" "276.946528271" "20171216" "276.1803804648" "20171217" "275.6915394176" "20171219" "278.548791134" "20171220" "278.7410531092" "20171222" "279.242002545" "20171223" "279.7527915878" "20171224" "281.4555713384" "20171225" "280.5558169586" "20171226" "278.4396134193" "20171227" "277.5737674598" "20171228" "277.9586292614" "20171229" "276.1686937737" "20171230" "276.0943640507" "20171231" "277.9560670178"} v ""))(defn enrich0toWF_2t_2953481_+0_max1559467755355 "Enrichment - Date to WF_2t_2953481_+0_max}" [v] (get {"20170101" "280.3095086608" "20170102" "277.4594677241" "20170103" "280.396410393" "20170104" "278.3345491043" "20170105" "273.5588354246" "20170106" "272.5933238328" "20170107" "278.0840805516" "20170108" "276.3906471946" "20170109" "277.3669951468" "20170110" "277.1817947542" "20170111" "278.285856613" "20170112" "277.9788682726" "20170113" "276.5756687973" "20170114" "276.1673571654" "20170115" "275.4472335661" "20170116" "274.5818783539" "20170117" "275.3511535953" "20170118" "277.1812583846" "20170119" "278.5885367345" "20170120" "278.3748717645" "20170121" "277.9748633799" "20170122" "277.1761264994" "20170123" "276.9067259509" "20170124" "277.4119885377" "20170126" "274.9745205966" "20170127" "275.5583422112" "20170128" "276.5943467882" "20170129" "277.5606011285" "20170130" "277.2952745226" "20170131" "276.5268850616" "20170201" "275.6952039931" "20170202" "276.6985849708" "20170203" "276.7866753472" "20170204" "277.5396568221" "20170205" "276.3130055437" "20170206" "275.6777393071" "20170207" "274.1401194563" "20170208" "272.6549799755" "20170209" "271.9038875079" "20170210" "273.5900928228" "20170211" "273.743070352" "20170212" "273.7942634351" "20170214" "275.5740165325" "20170215" "276.8038860283" "20170217" "278.3806226326" "20170218" "277.4040823272" "20170219" "278.4337713068" "20170220" "279.756152837" "20170221" "279.1544004498" "20170222" "279.585752545" "20170223" "278.652195786" "20170227" "280.0651362255" "20170302" "278.3889579388" "20170304" "279.0813382852" "20170305" "278.7708111387" "20170306" "276.9797659209" "20170307" "274.9989716501" "20170310" "279.3292840515" "20170312" "277.688530816" "20170315" "280.1864198627" "20170318" "278.5897673019" "20170319" "278.3327932647" "20170320" "280.1398284604" "20170323" "279.8206330887" "20170331" "284.4070909288" "20170402" "281.6226202454" "20170403" "280.2131446299" "20170405" "280.850492227" "20170412" "281.043299203" "20170415" "279.9818226207" "20170416" "279.1345856021" "20170417" "279.1463561395" "20170418" "277.9766858033" "20170419" "278.4113646228" "20170421" "282.4944390191" "20170422" "280.943139895" "20170423" "280.1366916233" "20170425" "279.1554214015" "20170426" "279.8735351562" "20170427" "280.1731598209" "20170429" "280.5490377407" "20170430" "281.8225911458" "20170501" "282.1406176018" "20170503" "282.9455196496" "20170507" "283.2043851602" "20170508" "281.3207415956" "20170510" "280.9357910156" "20170517" "287.7587668679" "20170522" "286.7948651555" "20170605" "288.26584448" "20170606" "290.2232283775" "20170607" "286.3821047388" "20170612" "288.4067604759" "20170615" "290.3602504538" "20170616" "288.265181108" "20170622" "290.7625350182" "20170623" "289.3424059935" "20170628" "289.8172126539" "20170702" "288.7215193932" "20170706" "289.0872593119" "20170707" "290.3192520912" "20170708" "289.8251903804" "20170709" "289.6893890073" "20170710" "289.9033178464" "20170711" "290.3789259785" "20170712" "288.4624516651" "20170713" "289.2423823193" "20170714" "289.3960725418" "20170716" "290.1365485914" "20170717" "289.9676673966" "20170718" "290.4934649227" "20170719" "291.7062075836" "20170721" "290.5485913826" "20170723" "290.4146247633" "20170729" "291.389039319" "20170808" "293.0851705532" "20170811" "290.2300174598" "20170813" "290.095372672" "20170814" "290.7761353772" "20170815" "293.4856721512" "20170817" "292.0817575166" "20170819" "289.7842512034" "20170820" "289.8496710267" "20170821" "290.240749783" "20170822" "290.2550628354" "20170823" "290.7859601878" "20170825" "291.206404869" "20170827" "290.6850462634" "20170828" "291.1172318892" "20170829" "293.0545346039" "20170907" "289.1679712161" "20170909" "288.7078499842" "20170910" "289.5705837674" "20170911" "289.0280219184" "20170912" "288.8004310685" "20170914" "287.2727716619" "20170915" "287.3883586845" "20170917" "286.9750434028" "20170923" "288.3958530619" "20170924" "289.2586558949" "20170925" "289.2175218987" "20170928" "288.6575619476" "20170929" "289.2766729798" "20170930" "288.3156836924" "20171001" "288.3292963818" "20171003" "287.0237827494" "20171004" "286.4770853062" "20171005" "286.0002786656" "20171008" "285.2754325481" "20171009" "285.727043383" "20171011" "287.8535476839" "20171012" "287.231462575" "20171013" "288.260761916" "20171014" "288.6372168955" "20171015" "288.7306043837" "20171016" "288.6269112019" "20171017" "288.8663589015" "20171018" "286.7278793797" "20171019" "286.9298453283" "20171020" "287.2607767124" "20171021" "286.4043363321" "20171022" "285.5784159959" "20171023" "285.3026949179" "20171024" "287.2530332623" "20171025" "287.5082588581" "20171026" "286.6444720644" "20171027" "284.8578978259" "20171028" "285.6121123343" "20171029" "284.3231016217" "20171030" "282.1556482797" "20171031" "285.1471872041" "20171101" "286.4046125316" "20171103" "284.1319493766" "20171104" "284.3265146583" "20171105" "284.2649640941" "20171106" "282.5291834359" "20171109" "283.7323824179" "20171111" "280.7236476089" "20171112" "280.9477736348" "20171113" "280.4365974195" "20171115" "283.2805422388" "20171116" "282.9712974471" "20171117" "282.2866038313" "20171118" "281.4815710819" "20171119" "280.5972641454" "20171120" "279.7842487374" "20171121" "280.3901169902" "20171122" "284.1210099037" "20171123" "284.2178128946" "20171124" "282.318507339" "20171125" "279.8677201705" "20171126" "280.3505908696" "20171127" "279.941887133" "20171128" "279.7231593277" "20171129" "277.8308130129" "20171130" "277.5244954427" "20171201" "277.6238236861" "20171202" "279.5817821772" "20171203" "280.4808435922" "20171204" "279.7701748935" "20171205" "282.030327691" "20171206" "282.177771366" "20171207" "281.9570534446" "20171208" "280.0266088621" "20171210" "276.3382250853" "20171211" "276.3165394176" "20171212" "278.0896661932" "20171213" "278.2396055279" "20171214" "278.3343098958" "20171215" "278.3491531526" "20171216" "277.6479418205" "20171217" "276.9931344697" "20171219" "279.3658928149" "20171220" "280.6225388652" "20171222" "279.5933233704" "20171223" "281.8900504064" "20171224" "282.1170420021" "20171225" "281.4601902817" "20171226" "279.7660590278" "20171227" "278.5999842172" "20171228" "278.4804958767" "20171229" "278.0146435054" "20171230" "278.2400839449" "20171231" "281.6852410827"} v ""))(defn enrich0toWF_rh_2953481_+0_avg1559467755355 "Enrichment - Date to WF_rh_2953481_+0_avg}" [v] (get {"20170101" "86.13267898437144" "20170102" "77.03234528972858" "20170103" "84.15197953965715" "20170104" "66.37024201902857" "20170105" "62.39316953952857" "20170106" "62.276678921300004" "20170107" "85.02204057534286" "20170108" "88.31550712855713" "20170109" "90.73901733791429" "20170110" "86.45349786235714" "20170111" "83.58912645155714" "20170112" "75.65942977898571" "20170113" "83.32995837754287" "20170114" "76.92965114081429" "20170115" "72.09052510108572" "20170116" "70.68264218218572" "20170117" "73.75046066092857" "20170118" "83.59495653474286" "20170119" "93.38003385472858" "20170120" "91.0793594764857" "20170121" "91.40345681972858" "20170122" "88.11312189444286" "20170123" "85.04870385102858" "20170124" "90.48937647657142" "20170126" "87.53327116924287" "20170127" "80.71603775941428" "20170128" "80.58407476930002" "20170129" "87.98456610532857" "20170130" "92.03532852894286" "20170131" "86.82054076915713" "20170201" "86.2786928018857" "20170202" "88.52412754308573" "20170203" "93.26139504838572" "20170204" "93.89240576728571" "20170205" "91.92467205538571" "20170206" "82.33209316261427" "20170207" "76.96108331142857" "20170208" "71.63946512714286" "20170209" "71.31172931619999" "20170210" "79.02384610661429" "20170211" "78.17216159737143" "20170212" "80.9462859281" "20170214" "79.86604982612857" "20170215" "82.00407647988573" "20170217" "93.37128029487144" "20170218" "92.93967955934285" "20170219" "93.63258898292857" "20170220" "93.05994001755714" "20170221" "82.97559487225715" "20170222" "80.80649664411429" "20170223" "88.2684364651" "20170227" "86.37171799519999" "20170302" "84.57479062088574" "20170304" "86.12920343742857" "20170305" "90.63775047674285" "20170306" "86.97307598357143" "20170307" "72.31686783631429" "20170310" "85.18310143141427" "20170312" "81.01614781514286" "20170315" "78.60049078784286" "20170318" "81.36190564637143" "20170319" "90.76206269318571" "20170320" "94.39044915047144" "20170323" "80.63947644137143" "20170331" "84.39783780074286" "20170402" "90.68998940991428" "20170403" "87.1580328056143" "20170405" "80.04304869047142" "20170412" "88.24606945837142" "20170415" "84.61335382242858" "20170416" "74.95141929857142" "20170417" "73.56818518974286" "20170418" "63.71122778277144" "20170419" "58.91719111552857" "20170421" "85.2379370330714" "20170422" "70.73910811997142" "20170423" "67.74535536228572" "20170425" "64.68273855944287" "20170426" "72.20670992434285" "20170427" "76.9703364218" "20170429" "77.75076454612858" "20170430" "75.96077700782858" "20170501" "73.07688355782857" "20170503" "67.19280912208572" "20170507" "83.95955242387141" "20170508" "67.42399844201428" "20170510" "81.44131713205715" "20170517" "88.07393368811428" "20170522" "83.73608693845713" "20170605" "79.78577923811429" "20170606" "78.54434685567142" "20170607" "81.35708424845714" "20170612" "80.79559101330001" "20170615" "85.01243137055714" "20170616" "82.75269863845713" "20170622" "85.91626595057143" "20170623" "89.17163730307142" "20170628" "79.56637985994287" "20170702" "79.60505705181428" "20170706" "74.97179692670001" "20170707" "87.1662171654" "20170708" "84.19440461939999" "20170709" "73.1663405729" "20170710" "83.40134612774285" "20170711" "85.85975149517142" "20170712" "78.34586465275713" "20170713" "68.5959705817" "20170714" "74.4815794521857" "20170716" "86.25614038311429" "20170717" "75.35553847471428" "20170718" "78.99514410125714" "20170719" "81.43071301171429" "20170721" "80.53807162772857" "20170723" "86.33736339667144" "20170729" "83.46691426814286" "20170808" "77.17321133255714" "20170811" "78.48370039804286" "20170813" "68.54959788438572" "20170814" "67.89946499112857" "20170815" "80.27429113072857" "20170817" "83.80378883724286" "20170819" "77.0325693467" "20170820" "79.11252541881427" "20170821" "75.27012910092857" "20170822" "72.56899580885714" "20170823" "75.65381360694286" "20170825" "78.65150970588572" "20170827" "80.08542223374286" "20170828" "82.15449143839999" "20170829" "81.16199055301429" "20170907" "76.33727295745715" "20170909" "81.48456076564285" "20170910" "76.86427185538572" "20170911" "79.52722476430002" "20170912" "78.23155583814287" "20170914" "82.12487938838571" "20170915" "80.71247591189999" "20170917" "81.88882379212858" "20170923" "85.30070501735715" "20170924" "87.66182851842856" "20170925" "85.41841373497144" "20170928" "83.74208526452857" "20170929" "85.87605161712858" "20170930" "82.89165726237142" "20171001" "78.74551806332856" "20171003" "78.46979527362858" "20171004" "76.67602897765713" "20171005" "76.50083937645715" "20171008" "68.63373971955716" "20171009" "73.78834590038572" "20171011" "86.78193819321429" "20171012" "76.34810898148571" "20171013" "84.29762327392858" "20171014" "92.17286098745716" "20171015" "90.6087793944" "20171016" "90.90504368624285" "20171017" "77.5134723674" "20171018" "85.70638686587142" "20171019" "90.55848763084286" "20171020" "89.58061795620002" "20171021" "88.04863439818571" "20171022" "84.94877043948573" "20171023" "84.82860656584286" "20171024" "87.98954210167143" "20171025" "85.58291567648573" "20171026" "79.89881189615714" "20171027" "76.08472068511428" "20171028" "78.24088186672857" "20171029" "64.69353960052857" "20171030" "59.89074445165714" "20171031" "76.88527990764285" "20171101" "89.22137781042859" "20171103" "78.12372838154285" "20171104" "85.01166891620001" "20171105" "79.2209670166" "20171106" "72.24584651272856" "20171109" "79.50376552545715" "20171111" "72.0936703351" "20171112" "78.85855500334286" "20171113" "73.41414028922858" "20171115" "85.13293918842858" "20171116" "87.75002282871428" "20171117" "72.81783590904287" "20171118" "79.35936060528572" "20171119" "76.09138974322858" "20171120" "73.95365917108572" "20171121" "84.85332333951429" "20171122" "87.7473002200857" "20171123" "73.22183880525714" "20171124" "76.18452087902857" "20171125" "77.54852021202858" "20171126" "81.22692451987143" "20171127" "84.05938951594285" "20171128" "82.38279247194285" "20171129" "84.25152672921429" "20171130" "84.61821011341429" "20171201" "80.47288092358572" "20171202" "80.12710927714286" "20171203" "81.76192652987142" "20171204" "77.29478404134285" "20171205" "85.02652016975716" "20171206" "85.25337868425716" "20171207" "81.91472124014285" "20171208" "77.08492125888571" "20171210" "81.72524913244285" "20171211" "79.5024150930857" "20171212" "78.4750067122857" "20171213" "85.25259579594285" "20171214" "83.29302897562857" "20171215" "84.45282049202856" "20171216" "80.18150203074286" "20171217" "78.14606277724286" "20171219" "90.62944620247143" "20171220" "95.0514706093857" "20171222" "86.6802643708" "20171223" "90.60185305331427" "20171224" "89.08192713577144" "20171225" "87.22177773037143" "20171226" "82.91146905671428" "20171227" "84.30944034854285" "20171228" "83.03768470577143" "20171229" "81.94309939002856" "20171230" "87.24102785605714" "20171231" "89.45097065615717"} v ""))(defn enrich0toWF_rh_2953481_+0_min1559467755355 "Enrichment - Date to WF_rh_2953481_+0_min}" [v] (get {"20170101" "78.2116251752" "20170102" "70.0673615826" "20170103" "79.0488656928" "20170104" "57.3038908965" "20170105" "57.8282388515" "20170106" "58.1757131479" "20170107" "73.5801249842" "20170108" "85.3357838654" "20170109" "90.0042172785" "20170110" "84.6286104397" "20170111" "77.7264443504" "20170112" "70.6048317398" "20170113" "80.2766736973" "20170114" "73.6398908199" "20170115" "67.0445630348" "20170116" "65.2513695247" "20170117" "69.3632234534" "20170118" "77.1473546302" "20170119" "89.8268151636" "20170120" "89.0286160297" "20170121" "89.6865573701" "20170122" "85.3967509179" "20170123" "82.8407175727" "20170124" "88.5850454611" "20170126" "85.9397741995" "20170127" "75.9388544114" "20170128" "76.6118835224" "20170129" "84.5274903665" "20170130" "90.168417199" "20170131" "84.2924922429" "20170201" "84.6479550556" "20170202" "87.2692310619" "20170203" "92.1073121574" "20170204" "91.0963956615" "20170205" "88.2262142586" "20170206" "78.1979186936" "20170207" "74.6595502606" "20170208" "68.5917634276" "20170209" "66.0767307395" "20170210" "75.9752512827" "20170211" "75.9992162654" "20170212" "77.7520584522" "20170214" "72.8209127987" "20170215" "77.6368623889" "20170217" "91.3113342215" "20170218" "89.4108790712" "20170219" "92.6082433624" "20170220" "89.7266667016" "20170221" "77.4581682796" "20170222" "74.7020668893" "20170223" "74.2078820674" "20170227" "82.6092119009" "20170302" "78.7020892797" "20170304" "83.4390387084" "20170305" "87.8678376375" "20170306" "81.5143521741" "20170307" "67.5630277062" "20170310" "78.5335928592" "20170312" "74.7288267345" "20170315" "73.2533701257" "20170318" "71.018783456" "20170319" "84.7671757724" "20170320" "91.0929623097" "20170323" "73.5925017322" "20170331" "80.3169180117" "20170402" "86.008611443" "20170403" "81.2404289975" "20170405" "75.121968828" "20170412" "84.4701077245" "20170415" "79.5790803914" "20170416" "67.9105727792" "20170417" "68.51678295" "20170418" "53.7921907109" "20170419" "50.6470608842" "20170421" "75.1328444573" "20170422" "67.0915758741" "20170423" "57.968637436" "20170425" "58.5042226541" "20170426" "65.3280214834" "20170427" "72.1166067671" "20170429" "71.4041028852" "20170430" "68.092737817" "20170501" "70.3639194667" "20170503" "64.9254254575" "20170507" "80.6360864239" "20170508" "57.9830924132" "20170510" "78.1499110218" "20170517" "82.8813472572" "20170522" "76.087773622" "20170605" "72.8217195382" "20170606" "73.7587601518" "20170607" "79.6824017424" "20170612" "76.844550325" "20170615" "77.8319133011" "20170616" "77.3678813997" "20170622" "81.8850225689" "20170623" "85.0179873333" "20170628" "76.3006519505" "20170702" "73.4867748921" "20170706" "67.9062002522" "20170707" "82.9184941207" "20170708" "76.4770870697" "20170709" "68.6101702858" "20170710" "79.5210069041" "20170711" "81.0662973061" "20170712" "70.5462033678" "20170713" "61.952274595" "20170714" "69.93278189" "20170716" "83.2158270246" "20170717" "68.8270582686" "20170718" "72.819307686" "20170719" "74.9906102068" "20170721" "72.4454316342" "20170723" "80.5878622217" "20170729" "79.2365132784" "20170808" "70.0917966731" "20170811" "74.2948623454" "20170813" "60.0921630793" "20170814" "59.0761651075" "20170815" "75.681605993" "20170817" "81.4132382386" "20170819" "72.5138182887" "20170820" "74.3752951466" "20170821" "69.0523695478" "20170822" "66.1268787295" "20170823" "67.626245779" "20170825" "72.5889538417" "20170827" "73.7287070022" "20170828" "76.744326491" "20170829" "77.5752448855" "20170907" "73.7061603431" "20170909" "79.0314217772" "20170910" "71.3545601392" "20170911" "76.2350203084" "20170912" "74.630467243" "20170914" "78.4795391939" "20170915" "77.8408326404" "20170917" "76.1835715894" "20170923" "79.8761374378" "20170924" "84.1978466485" "20170925" "80.6121353487" "20170928" "80.2549992287" "20170929" "82.9282847516" "20170930" "79.3013629425" "20171001" "75.9466437982" "20171003" "75.6866770158" "20171004" "71.1928417029" "20171005" "69.7258187241" "20171008" "59.4759336654" "20171009" "67.5588966947" "20171011" "84.0273556556" "20171012" "68.3034931667" "20171013" "77.3877060487" "20171014" "90.759718656" "20171015" "87.0170880974" "20171016" "89.0238818332" "20171017" "74.0700022324" "20171018" "81.1089485647" "20171019" "88.1697427186" "20171020" "87.2011744878" "20171021" "84.74453917" "20171022" "81.8113759355" "20171023" "81.4519065953" "20171024" "83.3504769433" "20171025" "80.4107864432" "20171026" "77.3373108896" "20171027" "69.574388167" "20171028" "72.4846112255" "20171029" "56.7628061203" "20171030" "55.8829573066" "20171031" "67.8555155419" "20171101" "85.1749165914" "20171103" "73.340202784" "20171104" "81.4160280009" "20171105" "75.5251444217" "20171106" "65.4734579086" "20171109" "78.4407214352" "20171111" "66.4220117844" "20171112" "70.228070163" "20171113" "68.3341517551" "20171115" "82.2481562653" "20171116" "78.6614741454" "20171117" "69.0080952394" "20171118" "73.8191611871" "20171119" "73.5807805455" "20171120" "69.5833162501" "20171121" "81.6292461046" "20171122" "79.2357215674" "20171123" "68.5825879896" "20171124" "74.714586536" "20171125" "73.6332871181" "20171126" "77.2695978334" "20171127" "82.0390689787" "20171128" "80.2342730053" "20171129" "81.3821843217" "20171130" "80.6977675127" "20171201" "77.0029918642" "20171202" "76.1463033161" "20171203" "74.5825818864" "20171204" "70.6170115611" "20171205" "83.06612097" "20171206" "83.1673058352" "20171207" "80.1249471474" "20171208" "71.2335465027" "20171210" "78.1213061438" "20171211" "76.1692138343" "20171212" "71.4816354339" "20171213" "77.8975352358" "20171214" "80.1348066511" "20171215" "83.1222115804" "20171216" "76.5596893138" "20171217" "74.9052464138" "20171219" "86.8160518424" "20171220" "92.8795296522" "20171222" "81.9517190215" "20171223" "87.1298984027" "20171224" "86.4127010665" "20171225" "85.6151167296" "20171226" "80.8423184631" "20171227" "81.3353093779" "20171228" "81.3111080173" "20171229" "78.6848498715" "20171230" "83.2022879626" "20171231" "87.7259625108"} v ""))(defn enrich0toWF_rh_2953481_+0_max1559467755355 "Enrichment - Date to WF_rh_2953481_+0_max}" [v] (get {"20170101" "91.4955053867" "20170102" "85.6290627137" "20170103" "88.3417619436" "20170104" "73.2655660881" "20170105" "68.4131016676" "20170106" "66.9129768268" "20170107" "89.6257184204" "20170108" "91.0224282392" "20170109" "91.772421061" "20170110" "89.7411975512" "20170111" "91.5622644711" "20170112" "81.519383452" "20170113" "85.1212413018" "20170114" "84.7862132761" "20170115" "76.1745451575" "20170116" "76.0593120913" "20170117" "76.7907322048" "20170118" "88.79488353" "20170119" "95.3394498779" "20170120" "93.5315590658" "20170121" "92.7396790288" "20170122" "91.3672391295" "20170123" "87.591799197" "20170124" "92.7778392746" "20170126" "90.3295045371" "20170127" "85.3130649581" "20170128" "84.6342666771" "20170129" "91.3879937448" "20170130" "94.3500799428" "20170131" "90.4588316907" "20170201" "88.2396297119" "20170202" "89.72148489" "20170203" "94.5450276703" "20170204" "95.3329648058" "20170205" "95.2374730274" "20170206" "88.4244403657" "20170207" "80.4044645913" "20170208" "74.8076799202" "20170209" "75.7814149342" "20170210" "81.2470363045" "20170211" "80.5134069346" "20170212" "83.7239073376" "20170214" "87.5858614116" "20170215" "86.187161444" "20170217" "95.4110143344" "20170218" "97.0620691553" "20170219" "95.5526643815" "20170220" "94.6512209187" "20170221" "89.7350995872" "20170222" "91.6087475242" "20170223" "94.7235809785" "20170227" "88.9040728171" "20170302" "90.0710089353" "20170304" "88.8509086603" "20170305" "92.0057415992" "20170306" "92.84628382" "20170307" "79.1537996756" "20170310" "90.4846235169" "20170312" "86.3702518187" "20170315" "86.6010617317" "20170318" "93.9015264553" "20170319" "95.4299300218" "20170320" "96.7934746734" "20170323" "88.3931262881" "20170331" "89.4180079242" "20170402" "95.2211728875" "20170403" "92.5007855402" "20170405" "89.7370283699" "20170412" "90.4322462719" "20170415" "90.9515792318" "20170416" "85.1368518016" "20170417" "78.8400963811" "20170418" "78.1512615043" "20170419" "66.5312798059" "20170421" "91.105791151" "20170422" "75.1684467104" "20170423" "76.625566228" "20170425" "70.9414456284" "20170426" "79.1624186334" "20170427" "83.6355342154" "20170429" "84.1502380864" "20170430" "85.9481797569" "20170501" "76.1076588364" "20170503" "71.8191725354" "20170507" "88.8402251349" "20170508" "85.3257367439" "20170510" "85.6570533264" "20170517" "92.1526164466" "20170522" "93.9249605498" "20170605" "89.9197042477" "20170606" "81.4361269675" "20170607" "82.670241241" "20170612" "89.097482236" "20170615" "92.252326226" "20170616" "88.0293365674" "20170622" "93.6126989508" "20170623" "94.9408567028" "20170628" "82.7170102877" "20170702" "89.0178561314" "20170706" "81.7139876189" "20170707" "92.5594238228" "20170708" "93.8083250877" "20170709" "81.7240610792" "20170710" "88.4189558847" "20170711" "91.6236081062" "20170712" "85.4279182576" "20170713" "77.6059212931" "20170714" "80.1035249034" "20170716" "88.6116511523" "20170717" "83.6063755393" "20170718" "85.6848834191" "20170719" "89.3488315484" "20170721" "93.9691408956" "20170723" "91.7541373228" "20170729" "87.1929742064" "20170808" "83.9647213481" "20170811" "82.7415169065" "20170813" "80.9746587314" "20170814" "74.989989499" "20170815" "85.4343049316" "20170817" "89.591621063" "20170819" "81.5673844351" "20170820" "82.7107897822" "20170821" "84.3227321102" "20170822" "79.5177873106" "20170823" "84.2391235481" "20170825" "85.7848048582" "20170827" "86.7260485859" "20170828" "87.1841179743" "20170829" "84.9087800235" "20170907" "79.3140412259" "20170909" "85.1578086795" "20170910" "83.9834463832" "20170911" "81.8796652985" "20170912" "82.3257351655" "20170914" "84.9702652866" "20170915" "84.1848106238" "20170917" "86.1676592807" "20170923" "90.8211577623" "20170924" "90.1464556967" "20170925" "92.02844246" "20170928" "86.4851961979" "20170929" "90.3700150394" "20170930" "85.6213561986" "20171001" "80.1651025793" "20171003" "83.6024188788" "20171004" "84.2793541223" "20171005" "80.0349990754" "20171008" "81.844552625" "20171009" "81.8762466576" "20171011" "88.5918643743" "20171012" "86.2215767216" "20171013" "88.320255834" "20171014" "93.4427922362" "20171015" "95.9708040567" "20171016" "93.4059719216" "20171017" "86.2262871281" "20171018" "89.336953991" "20171019" "92.0048126754" "20171020" "92.577067997" "20171021" "91.8705230975" "20171022" "88.0302497673" "20171023" "88.5583634644" "20171024" "91.6824879888" "20171025" "92.601427983" "20171026" "81.5400570858" "20171027" "82.0015582541" "20171028" "81.6229463086" "20171029" "79.257866059" "20171030" "63.8716304848" "20171031" "87.57169314" "20171101" "92.3144867473" "20171103" "81.2217886929" "20171104" "87.2589115578" "20171105" "87.8362806523" "20171106" "81.7495981912" "20171109" "81.2094637752" "20171111" "77.0751538114" "20171112" "83.2959720774" "20171113" "79.7201332727" "20171115" "89.4289655532" "20171116" "91.3038251357" "20171117" "78.5901363006" "20171118" "85.4695248353" "20171119" "81.1213830015" "20171120" "80.03901183" "20171121" "88.7290582083" "20171122" "92.3148194271" "20171123" "75.9234636917" "20171124" "77.3696137507" "20171125" "81.1854536627" "20171126" "84.1837902632" "20171127" "85.8060160346" "20171128" "85.300712398" "20171129" "88.7311258497" "20171130" "87.8310743352" "20171201" "84.1440002719" "20171202" "86.7308969277" "20171203" "88.9808797559" "20171204" "84.0353381757" "20171205" "87.7594792138" "20171206" "86.1212187768" "20171207" "83.9694879685" "20171208" "81.1640700546" "20171210" "84.570861385" "20171211" "84.4485162689" "20171212" "88.1068706158" "20171213" "89.8103673675" "20171214" "90.9962901974" "20171215" "86.5421672898" "20171216" "84.9552171276" "20171217" "81.4099009084" "20171219" "93.1585532653" "20171220" "96.7153062363" "20171222" "93.4099675182" "20171223" "92.976906547" "20171224" "91.9356958288" "20171225" "90.1377356667" "20171226" "86.4057385767" "20171227" "86.7302087547" "20171228" "85.0450102803" "20171229" "84.6495018653" "20171230" "90.0378714417" "20171231" "91.6438703072"} v ""))(defn enrich0toWF_sd_2953481_+0_avg1559467755355 "Enrichment - Date to WF_sd_2953481_+0_avg}" [v] (get {"20170101" "0.0000038795" "20170102" "0.00001913748571428571" "20170103" "0.00003782787142857143" "20170104" "0.00003078957142857143" "20170105" "0.00010033670000000003" "20170106" "0.00018123654285714285" "20170107" "0.00036880102857142857" "20170108" "0.00016285732857142856" "20170109" "0.00009558781428571429" "20170110" "0.0000548104" "20170111" "0.000171279" "20170112" "0.00006771627142857143" "20170113" "0.00003077351428571429" "20170114" "0.000035953371428571425" "20170115" "0.0001376526" "20170116" "0.00006824902857142857" "20170117" "0.000056497328571428574" "20170118" "0.00007016428571428571" "20170119" "0.00002642308571428571" "20170120" "0.00000669377142857143" "20170122" "3.9637142857142853e-7" "20170123" "0.000009924542857142858" "20170126" "4.638714285714285e-7" "20170129" "0.0000012012285714285714" "20170130" "0.00009446564285714284" "20170131" "4.275142857142857e-7" "20170201" "0.0000031300285714285712" "20170202" "0.0000012347714285714285" "20170203" "2.1704285714285714e-7" "20170205" "0.00002279847142857143" "20170206" "0.000275806" "20170207" "0.0003530392142857143" "20170208" "0.0004170294428571429" "20170209" "0.0010401901571428572" "20170210" "0.0012729951" "20170211" "0.0007379680285714285" "20170212" "0.0005876348714285714" "20170214" "0.00040709525714285714" "20170215" "0.00018801554285714285" "20170217" "0.000008915185714285715" "20170218" "7.725142857142857e-7" "20170223" "0.0002743866142857143" "20170302" "0.00003688797142857142" "20170304" "0.00000207" "20170305" "1.8817142857142859e-7" "20170306" "0.000002763185714285714" "20170307" "0.000033568199999999995" "20170318" "0.00005028434285714286" "20170319" "0.00018176432857142856" "20170320" "0.000035144257142857145" "20170415" "0.000001219542857142857" "20170416" "0.00002579527142857143" "20170417" "0.0000295357" "20170418" "0.00008189947142857143" "20170419" "0.00003709855714285714" "20170423" "2.417142857142857e-8" "20170425" "0.00004863175714285714" "20170426" "0.00003526395714285715" "20170427" "0.000012424514285714285" "20170429" "0.000001829542857142857" "20170510" "4.454857142857143e-7" "20171029" "1.1252857142857143e-7" "20171111" "0.000017897228571428574" "20171112" "0.000010785699999999999" "20171113" "6.688142857142856e-7" "20171118" "0.000009350885714285715" "20171119" "0.0000329606" "20171120" "0.000030908485714285716" "20171121" "0.000012015557142857141" "20171122" "0.000008081628571428571" "20171125" "0.000001478657142857143" "20171126" "0.000010067300000000001" "20171127" "0.000005047214285714285" "20171128" "0.0000149776" "20171129" "0.0000027907285714285718" "20171130" "0.00001668422857142857" "20171201" "0.0000247999" "20171202" "0.000008834642857142858" "20171208" "0.0000472668" "20171210" "0.0006569783142857142" "20171211" "0.0006697542857142857" "20171212" "0.0014047902142857143" "20171213" "0.0009201033571428571" "20171214" "0.0005809122285714285" "20171215" "0.00014284445714285711" "20171216" "0.00007927862857142856" "20171217" "0.00004900144285714285" "20171219" "0.000007946257142857143" "20171220" "0.0000016359428571428574" "20171226" "0.000006998214285714285" "20171227" "0.0000046214142857142855" "20171228" "0.0000041350857142857145" "20171229" "0.000029212685714285715" "20171230" "0.00010128687142857143" "20171231" "0.000024109742857142857"} v ""))(defn enrich0toWF_sd_2953481_+0_min1559467755355 "Enrichment - Date to WF_sd_2953481_+0_min}" [v] (get {"20170101" "0.0000031169" "20170102" "0.0000035615" "20170103" "0.0000170593" "20170104" "0.0000050033" "20170105" "0.0000916564" "20170106" "0.0001788547" "20170107" "0.0001792443" "20170108" "0.0001607065" "20170109" "0.0000816695" "20170110" "0.0000523461" "20170111" "0.0000370532" "20170112" "0.0000566822" "20170113" "0.0000248128" "20170114" "0.0000126774" "20170115" "0.0001036851" "20170116" "0.0000681028" "20170117" "0.0000550834" "20170118" "0.0000412618" "20170119" "0.0000155047" "20170120" "0.0000046729" "20170130" "6.773e-7" "20170131" "3.459e-7" "20170206" "0.0001620921" "20170207" "0.0001880129" "20170208" "0.0002874636" "20170209" "0.001001361" "20170210" "0.0012638391" "20170211" "0.0007238349" "20170212" "0.0005623605" "20170214" "0.0003970744" "20170215" "0.0001749375" "20170217" "0.0000054698" "20170218" "5.199e-7" "20170302" "0.0000274199" "20170304" "0.0000012126" "20170318" "0.0000411693" "20170319" "0.0000217984" "20170320" "0.0000162227" "20170416" "0.0000044541" "20170417" "0.0000151739" "20170418" "0.0000722453" "20170419" "0.0000293776" "20170426" "0.0000302448" "20170427" "0.0000061986" "20170510" "2.005e-7" "20171111" "0.0000053618" "20171112" "0.0000098811" "20171113" "5.519e-7" "20171119" "0.0000153634" "20171120" "0.0000234076" "20171121" "0.0000100747" "20171122" "0.0000025428" "20171126" "0.0000052586" "20171127" "0.0000021983" "20171128" "0.0000113824" "20171129" "0.0000021187" "20171130" "7.589e-7" "20171201" "0.0000221207" "20171202" "0.000005399" "20171210" "0.0001678891" "20171211" "0.000559867" "20171212" "0.0012775223" "20171213" "0.0008243828" "20171214" "0.0003212958" "20171215" "0.0001345722" "20171216" "0.0000755895" "20171217" "0.0000415661" "20171219" "0.0000065105" "20171220" "9.612e-7" "20171227" "0.0000035691" "20171228" "0.0000033508" "20171229" "0.0000033794" "20171230" "0.0000329246" "20171231" "0.0000120164"} v ""))(defn enrich0toWF_sd_2953481_+0_max1559467755355 "Enrichment - Date to WF_sd_2953481_+0_max}" [v] (get {"20170101" "0.0000062028" "20170102" "0.0000649907" "20170103" "0.0000549516" "20170104" "0.0000952726" "20170105" "0.0001042846" "20170106" "0.0001932336" "20170107" "0.000456136" "20170108" "0.0001663688" "20170109" "0.0001169731" "20170110" "0.0000569503" "20170111" "0.0002938903" "20170112" "0.0000902864" "20170113" "0.000035944" "20170114" "0.0000632176" "20170115" "0.0001440682" "20170116" "0.0000684415" "20170117" "0.0000571675" "20170118" "0.0000799863" "20170119" "0.0000394708" "20170120" "0.0000098455" "20170122" "0.0000024328" "20170123" "0.0000125954" "20170126" "6.108e-7" "20170129" "0.0000028713" "20170130" "0.0002235677" "20170131" "5.611e-7" "20170201" "0.000004408" "20170202" "0.0000015019" "20170203" "2.881e-7" "20170205" "0.0001244852" "20170206" "0.0003337138" "20170207" "0.0005194572" "20170208" "0.0005231439" "20170209" "0.0010661137" "20170210" "0.0012811546" "20170211" "0.0007575651" "20170212" "0.0006003771" "20170214" "0.0004167162" "20170215" "0.0002012448" "20170217" "0.000014225" "20170218" "0.0000010717" "20170223" "0.0008414532" "20170302" "0.0000489177" "20170304" "0.0000030564" "20170305" "3.664e-7" "20170306" "0.0000078007" "20170307" "0.0000623519" "20170318" "0.0000590522" "20170319" "0.000422112" "20170320" "0.0000674565" "20170415" "0.0000061763" "20170416" "0.0000381407" "20170417" "0.0000512805" "20170418" "0.0000954523" "20170419" "0.0000454145" "20170423" "4.97e-8" "20170425" "0.0000784773" "20170426" "0.0000416934" "20170427" "0.0000185009" "20170429" "0.0000033321" "20170510" "7.405e-7" "20171029" "3.012e-7" "20171111" "0.0000286394" "20171112" "0.0000117254" "20171113" "7.506e-7" "20171118" "0.0000243258" "20171119" "0.0000449732" "20171120" "0.0000349696" "20171121" "0.000013194" "20171122" "0.0000141541" "20171125" "0.0000103506" "20171126" "0.0000140282" "20171127" "0.0000101292" "20171128" "0.000019831" "20171129" "0.0000037835" "20171130" "0.0000266171" "20171201" "0.0000267939" "20171202" "0.0000109826" "20171208" "0.0000794039" "20171210" "0.0008527573" "20171211" "0.0010139024" "20171212" "0.0014792551" "20171213" "0.0010403819" "20171214" "0.0007416741" "20171215" "0.0001496661" "20171216" "0.000082286" "20171217" "0.0000503439" "20171219" "0.0000101244" "20171220" "0.0000023797" "20171226" "0.0000127235" "20171227" "0.0000060649" "20171228" "0.0000064048" "20171229" "0.0000489517" "20171230" "0.0002100621" "20171231" "0.000032555"} v ""))(defn enrich0toWF_sp_2953481_+0_avg1559467755355 "Enrichment - Date to WF_sp_2953481_+0_avg}" [v] (get {"20170101" "101105.2545093795" "20170102" "101401.90115440117" "20170103" "100662.2141955267" "20170104" "100283.65449134202" "20170105" "103098.02913059165" "20170106" "103741.65151515149" "20170107" "102417.98665223666" "20170108" "102752.46320346322" "20170109" "101848.57801226553" "20170110" "100712.91486291487" "20170111" "99365.38329725829" "20170112" "99358.59433621934" "20170113" "99009.5782828283" "20170114" "100075.43344155843" "20170115" "101489.95661976912" "20170116" "102634.09370490619" "20170117" "103510.62202380956" "20170118" "103591.01957070708" "20170119" "103369.39015151515" "20170120" "103197.95716089466" "20170121" "103026.05275974025" "20170122" "102698.92604617601" "20170123" "102271.82079725827" "20170124" "102526.36273448775" "20170126" "102882.2022005772" "20170127" "102134.19381313132" "20170128" "101709.82205988457" "20170129" "101402.27552308803" "20170130" "101325.27408008659" "20170131" "101786.59613997115" "20170201" "101782.0295815296" "20170202" "100953.47429653679" "20170203" "100462.09054834057" "20170204" "100183.82665945166" "20170205" "100632.87247474746" "20170206" "102085.47465728715" "20170207" "102525.94246031744" "20170208" "103119.07584776335" "20170209" "103371.1186868687" "20170210" "103014.74837662339" "20170211" "103019.00315656567" "20170212" "103548.13311688311" "20170214" "103448.3372113997" "20170215" "103127.65701659452" "20170217" "101863.05393217893" "20170218" "102129.32278138529" "20170219" "101319.46194083695" "20170220" "100390.87202380954" "20170221" "100332.65521284273" "20170222" "99231.52362914864" "20170223" "98594.2288961039" "20170227" "99503.86823593076" "20170302" "99736.27092352093" "20170304" "99530.34803391054" "20170305" "99595.54121572872" "20170306" "100328.35173160174" "20170307" "101341.56727994226" "20170310" "102065.66215728717" "20170312" "102177.6130952381" "20170315" "102378.2058982684" "20170318" "99669.33441558441" "20170319" "100075.0211038961" "20170320" "99822.2774170274" "20170323" "102275.4348845599" "20170331" "101221.19489538237" "20170402" "101602.40620490622" "20170403" "102526.9108044733" "20170405" "101805.39727633477" "20170412" "100555.4037698413" "20170415" "100466.80753968256" "20170416" "101279.2663239538" "20170417" "101522.2958152958" "20170418" "102806.05492424245" "20170419" "103542.9364177489" "20170421" "101893.80122655121" "20170422" "101519.4466991342" "20170423" "101650.28192640693" "20170425" "100277.96825396828" "20170426" "100967.90088383839" "20170427" "101058.05402236652" "20170429" "101601.01984126985" "20170430" "101911.50829725832" "20170501" "101794.63356782103" "20170503" "102645.47564935066" "20170507" "101293.45093795094" "20170508" "101857.76280663781" "20170510" "100671.97168109668" "20170517" "101963.89754689754" "20170522" "102020.5265151515" "20170605" "101041.05221861471" "20170606" "100048.17261904762" "20170607" "100033.46392496394" "20170612" "100638.28841991343" "20170615" "101314.71031746033" "20170616" "101158.20689033189" "20170622" "100724.9981962482" "20170623" "100679.44958513707" "20170628" "100217.14808802307" "20170702" "101102.711038961" "20170706" "101821.32783189032" "20170707" "101247.7252886003" "20170708" "101251.20075757577" "20170709" "101336.43488455992" "20170710" "100814.06863275614" "20170711" "100641.08459595959" "20170712" "100836.40710678209" "20170713" "101656.38825757576" "20170714" "101393.97411616161" "20170716" "101719.77074314574" "20170717" "101893.87545093798" "20170718" "102013.32341269842" "20170719" "101450.55546536797" "20170721" "101274.3143037518" "20170723" "100990.2481060606" "20170729" "100749.5762987013" "20170808" "101245.78778860028" "20170811" "101460.2325937951" "20170813" "101648.32025613276" "20170814" "102209.03012265512" "20170815" "101547.55672799423" "20170817" "101396.78210678209" "20170819" "100946.54572510823" "20170820" "101448.19191919193" "20170821" "101757.86625180375" "20170822" "101891.26208513709" "20170823" "101706.13474025973" "20170825" "101492.8547077922" "20170827" "101481.34938672438" "20170828" "101818.73737373736" "20170829" "101282.5945165945" "20170907" "100699.38419913419" "20170909" "99448.50910894662" "20170910" "99814.83784271285" "20170911" "99182.21527777777" "20170912" "99728.06809163057" "20170914" "99299.49783549784" "20170915" "100369.6918290043" "20170917" "101202.13455988454" "20170923" "102282.39953102452" "20170924" "102448.1158008658" "20170925" "102471.87355699854" "20170928" "102552.96266233767" "20170929" "102204.25649350649" "20170930" "101642.88852813853" "20171001" "101641.26776695528" "20171003" "100814.32296176047" "20171004" "100801.07151875902" "20171005" "99854.84550865799" "20171008" "101051.33026695528" "20171009" "101321.66883116883" "20171011" "100627.86327561327" "20171012" "100854.82431457432" "20171013" "101809.44444444445" "20171014" "101918.41946248195" "20171015" "101976.20824314572" "20171016" "101742.81583694085" "20171017" "101456.56186868688" "20171018" "101378.26136363637" "20171019" "101273.29121572872" "20171020" "100873.1213924964" "20171021" "100904.6691017316" "20171022" "100593.95084776336" "20171023" "101317.31682900432" "20171024" "101611.51524170276" "20171025" "101207.67442279945" "20171026" "101583.5753066378" "20171027" "101751.09902597404" "20171028" "100314.58107864356" "20171029" "100001.58504689754" "20171030" "101793.04689754688" "20171031" "101766.62518037518" "20171101" "101096.5652056277" "20171103" "101205.92739898992" "20171104" "100483.40115440114" "20171105" "100407.03021284273" "20171106" "101885.03832972582" "20171109" "101576.3933080808" "20171111" "99917.74675324676" "20171112" "99802.12463924964" "20171113" "101188.00468975469" "20171115" "102071.21572871573" "20171116" "101849.29834054834" "20171117" "101933.05772005774" "20171118" "100611.59568903317" "20171119" "100370.24900793652" "20171120" "100986.77949134198" "20171121" "100747.80690836941" "20171122" "99901.95183982681" "20171123" "99615.54157647908" "20171124" "100526.94191919193" "20171125" "100676.50297619049" "20171126" "100794.29428210677" "20171127" "100341.13401875901" "20171128" "99512.47402597402" "20171129" "100182.22817460318" "20171130" "100249.79707792206" "20171201" "101453.09172077922" "20171202" "102061.70039682541" "20171203" "101499.20932539682" "20171204" "101945.3491161616" "20171205" "102081.1700036075" "20171206" "101670.16486291485" "20171207" "100266.6178751804" "20171208" "99619.64655483402" "20171210" "98696.28914141418" "20171211" "98559.13347763348" "20171212" "99513.56376262625" "20171213" "99497.99062049063" "20171214" "98205.62481962482" "20171215" "99179.5854076479" "20171216" "100287.45580808082" "20171217" "101568.02768759019" "20171219" "102776.52462121213" "20171220" "102874.55059523808" "20171222" "102805.01650432903" "20171223" "101742.07368326116" "20171224" "101015.66838023088" "20171225" "100530.73169191918" "20171226" "99219.51253607504" "20171227" "98583.62779581528" "20171228" "98797.2362012987" "20171229" "99705.77290764792" "20171230" "99271.3446969697" "20171231" "99336.75144300143"} v ""))(defn enrich0toWF_sp_2953481_+0_min1559467755355 "Enrichment - Date to WF_sp_2953481_+0_min}" [v] (get {"20170101" "100991.3106060606" "20170102" "101155.4412878788" "20170103" "99870.3667929293" "20170104" "99473.2171717172" "20170105" "101827.490530303" "20170106" "103314.865530303" "20170107" "102143.7089646465" "20170108" "102502.4154040404" "20170109" "101046.4185606061" "20170110" "100597.2796717172" "20170111" "98851.033459596" "20170112" "99140.1319444444" "20170113" "98770.202020202" "20170114" "99588.720959596" "20170115" "100719.4444444444" "20170116" "102246.8131313131" "20170117" "103237.6092171717" "20170118" "103477.408459596" "20170119" "103274.2481060606" "20170120" "103069.7493686869" "20170121" "102953.5763888889" "20170122" "102501.9356060606" "20170123" "102163.9886363636" "20170124" "102286.8920454545" "20170126" "102634.8712121212" "20170127" "101992.0827020202" "20170128" "101467.0625" "20170129" "101334.8977272727" "20170130" "101201.494949495" "20170131" "101520.0069444444" "20170201" "101460.9696969697" "20170202" "100705.2455808081" "20170203" "100295.9375" "20170204" "100047.4577020202" "20170205" "100368.6672979798" "20170206" "101390.2108585859" "20170207" "102427.2891414141" "20170208" "102786.904040404" "20170209" "103317.321969697" "20170210" "102869.922979798" "20170211" "102904.1679292929" "20170212" "103154.5018939394" "20170214" "103360.5075757576" "20170215" "102856.5132575758" "20170217" "101617.6856060606" "20170218" "101870.4128787879" "20170219" "101172.428030303" "20170220" "99994.5744949495" "20170221" "100156.029040404" "20170222" "98972.9097222222" "20170223" "97821.0404040404" "20170227" "98672.9185606061" "20170302" "99273.5568181818" "20170304" "99302.5" "20170305" "99331.2373737374" "20170306" "100057.0397727273" "20170307" "100930.0467171717" "20170310" "101683.3806818182" "20170312" "102054.4741161616" "20170315" "102195.6313131313" "20170318" "98958.1035353535" "20170319" "99781.0416666667" "20170320" "99454.3282828283" "20170323" "101992.211489899" "20170331" "100960.2481060606" "20170402" "101170.6123737374" "20170403" "102282.5568181818" "20170405" "101475.0997474747" "20170412" "100293.0839646465" "20170415" "100283.5271464647" "20170416" "100813.6641414141" "20170417" "101368.2417929293" "20170418" "101980.0801767677" "20170419" "103399.2746212121" "20170421" "101540.9823232323" "20170422" "101452.0309343434" "20170423" "101619.3775252525" "20170425" "100123.8055555556" "20170426" "100598.1900252525" "20170427" "100949.2992424242" "20170429" "101260.3345959596" "20170430" "101721.7714646465" "20170501" "101680.9393939394" "20170503" "102470.5056818182" "20170507" "101234.755050505" "20170508" "101334.2001262626" "20170510" "100522.5056818182" "20170517" "101447.533459596" "20170522" "101673.0321969697" "20170605" "100837.8049242424" "20170606" "99759.4829545455" "20170607" "99771.2910353535" "20170612" "100502.9065656566" "20170615" "100919.5928030303" "20170616" "100887.5227272727" "20170622" "100262.9526515152" "20170623" "100328.7222222222" "20170628" "99742.442550505" "20170702" "100873.0978535353" "20170706" "101632.2941919192" "20170707" "101149.3876262626" "20170708" "101153.4217171717" "20170709" "101188.8099747475" "20170710" "100581.2367424242" "20170711" "100573.0189393939" "20170712" "100697.2765151515" "20170713" "101375.0012626263" "20170714" "101268.5202020202" "20170716" "101638.6224747475" "20170717" "101818.976010101" "20170718" "101876.2190656566" "20170719" "101099.4393939394" "20170721" "100895.2039141414" "20170723" "100888.0751262626" "20170729" "100572.279040404" "20170808" "100848.3068181818" "20170811" "101113.5063131313" "20170813" "101103.5366161616" "20170814" "102095.0902777778" "20170815" "101311.5448232323" "20170817" "101060.1376262626" "20170819" "100662.9053030303" "20170820" "101258.8787878788" "20170821" "101624.2904040404" "20170822" "101860.3705808081" "20170823" "101500.4848484848" "20170825" "101321.8611111111" "20170827" "101282.0321969697" "20170828" "101728.529040404" "20170829" "101077.8503787879" "20170907" "100612.6938131313" "20170909" "99318.2847222222" "20170910" "99571.4330808081" "20170911" "99116.0435606061" "20170912" "99291.9078282828" "20170914" "98775.4690656566" "20170915" "100019.0069444444" "20170917" "101155.5347222222" "20170923" "102189.0568181818" "20170924" "102315.2897727273" "20170925" "102412.875" "20170928" "102493.8674242424" "20170929" "101946.6029040404" "20170930" "101496.9457070707" "20171001" "101385.0025252525" "20171003" "100340.6243686869" "20171004" "100466.4381313131" "20171005" "99519.1123737374" "20171008" "100324.2657828283" "20171009" "101119.6597222222" "20171011" "100519.2986111111" "20171012" "100293.2493686869" "20171013" "101605.1799242424" "20171014" "101761.6881313131" "20171015" "101736.4652777778" "20171016" "101645.904040404" "20171017" "101348.3888888889" "20171018" "101323.279040404" "20171019" "101097.6073232323" "20171020" "100808.2316919192" "20171021" "100803.7607323232" "20171022" "100524.4305555556" "20171023" "100791.0549242424" "20171024" "101237.2758838384" "20171025" "100887.610479798" "20171026" "101374.6893939394" "20171027" "101326.3794191919" "20171028" "99331.0763888889" "20171029" "98735.3516414141" "20171030" "101260.9286616162" "20171031" "101430.773989899" "20171101" "100698.5031565657" "20171103" "101034.0088383838" "20171104" "99933.1603535353" "20171105" "99983.1578282828" "20171106" "101115.3301767677" "20171109" "101304.1319444444" "20171111" "99858.5782828283" "20171112" "99645.6123737374" "20171113" "100372.4589646465" "20171115" "101862.5056818182" "20171116" "101585.6508838384" "20171117" "101626.0580808081" "20171118" "100220.0523989899" "20171119" "99919.4444444444" "20171120" "100871.9217171717" "20171121" "100447.6414141414" "20171122" "99781.216540404" "20171123" "99341.2424242424" "20171124" "100266.1837121212" "20171125" "100613.5568181818" "20171126" "100665.9160353535" "20171127" "99682.1426767677" "20171128" "99275.2285353535" "20171129" "99897.1287878788" "20171130" "100050.7443181818" "20171201" "100822.3093434343" "20171202" "101861.6287878788" "20171203" "101403.264520202" "20171204" "101550.3869949495" "20171205" "101906.5625" "20171206" "101469.115530303" "20171207" "99634.4387626263" "20171208" "99525.7948232323" "20171210" "97985.4097222222" "20171211" "98092.2828282828" "20171212" "98508.4545454545" "20171213" "98386.8137626263" "20171214" "97879.2941919192" "20171215" "98608.0744949495" "20171216" "99776.9829545455" "20171217" "101030.9236111111" "20171219" "102591.047979798" "20171220" "102740.3693181818" "20171222" "102734.0422979798" "20171223" "101322.0694444444" "20171224" "100785.8819444444" "20171225" "100179.7866161616" "20171226" "98967.7361111111" "20171227" "98295.216540404" "20171228" "98357.240530303" "20171229" "99403.9356060606" "20171230" "98944.9255050505" "20171231" "99072.7809343434"} v ""))(defn enrich0toWF_sp_2953481_+0_max1559467755355 "Enrichment - Date to WF_sp_2953481_+0_max}" [v] (get {"20170101" "101504.4494949495" "20170102" "101487.8491161616" "20170103" "101502.6818181818" "20170104" "101451.8851010101" "20170105" "103805.9393939394" "20170106" "103965.8857323232" "20170107" "103111.2960858586" "20170108" "102876.8295454545" "20170109" "102666.0151515152" "20170110" "100849.8226010101" "20170111" "100698.9103535353" "20170112" "99471.7361111111" "20170113" "99268.4507575758" "20170114" "100518.4387626263" "20170115" "102069.4507575758" "20170116" "103019.9375" "20170117" "103618.4267676768" "20170118" "103690.9330808081" "20170119" "103502.6830808081" "20170120" "103391.1281565657" "20170121" "103128.8787878788" "20170122" "102946.1773989899" "20170123" "102501.8383838384" "20170124" "102739.0082070707" "20170126" "103132.3200757576" "20170127" "102518.336489899" "20170128" "101979.8055555556" "20170129" "101472.7954545455" "20170130" "101529.2424242424" "20170131" "101979.7462121212" "20170201" "102008.0113636364" "20170202" "101348.4722222222" "20170203" "100680.0523989899" "20170204" "100263.7960858586" "20170205" "101125.0902777778" "20170206" "102421.7316919192" "20170207" "102693.1862373737" "20170208" "103351.5296717172" "20170209" "103440.2190656566" "20170210" "103262.2430555556" "20170211" "103192.6167929293" "20170212" "103787.4867424242" "20170214" "103601.5965909091" "20170215" "103351.8970959596" "20170217" "102122.490530303" "20170218" "102242.6085858586" "20170219" "101764.3301767677" "20170220" "101174.2575757576" "20170221" "100523.4507575758" "20170222" "99918.6066919192" "20170223" "99239.5132575758" "20170227" "100134.6553030303" "20170302" "100340.327020202" "20170304" "100010.0928030303" "20170305" "99900.6508838384" "20170306" "100685.6136363636" "20170307" "101612.3667929293" "20170310" "102314.8983585859" "20170312" "102341.8023989899" "20170315" "102464.9715909091" "20170318" "100334.8112373737" "20170319" "100502.2045454545" "20170320" "100075.8213383838" "20170323" "102554.658459596" "20170331" "101691.7904040404" "20170402" "102047.6666666667" "20170403" "102635.8529040404" "20170405" "102257.0359848485" "20170412" "101185.4305555556" "20170415" "100777.6571969697" "20170416" "101413.9968434343" "20170417" "101798.4779040404" "20170418" "103274.6887626263" "20170419" "103645.7575757576" "20170421" "102513.4292929293" "20170422" "101600.5751262626" "20170423" "101673.9962121212" "20170425" "100482.7430555556" "20170426" "101168.726010101" "20170427" "101199.5669191919" "20170429" "101934.6761363636" "20170430" "102079.8547979798" "20170501" "102010.9444444444" "20170503" "102760.077020202" "20170507" "101363.7613636364" "20170508" "102146.0902777778" "20170510" "100984.7727272727" "20170517" "102408.5858585859" "20170522" "102372" "20170605" "101171.9356060606" "20170606" "100690.9539141414" "20170607" "100464.2493686869" "20170612" "100702.9974747475" "20170615" "101705.8446969697" "20170616" "101463.6174242424" "20170622" "101379.3472222222" "20170623" "100843.5404040404" "20170628" "100811.6616161616" "20170702" "101399.9053030303" "20170706" "101954.1174242424" "20170707" "101566.788510101" "20170708" "101365.7398989899" "20170709" "101463.6363636364" "20170710" "101183.9955808081" "20170711" "100747.1578282828" "20170712" "101147.3585858586" "20170713" "101788.3661616162" "20170714" "101659.7746212121" "20170716" "101932.6755050505" "20170717" "101975.0845959596" "20170718" "102107.3731060606" "20170719" "101862.946969697" "20170721" "101468.8314393939" "20170723" "101277.8863636364" "20170729" "100938.7228535353" "20170808" "101699.4330808081" "20170811" "101884.1830808081" "20170813" "102056.5965909091" "20170814" "102333.5467171717" "20170815" "101962.369949495" "20170817" "101889.0467171717" "20170819" "101205.038510101" "20170820" "101601.5902777778" "20170821" "101895.1433080808" "20170822" "101909.8023989899" "20170823" "101868.5625" "20170825" "101648.9444444444" "20170827" "101709.2190656566" "20170828" "101910.8068181818" "20170829" "101670.5972222222" "20170907" "100732.1660353535" "20170909" "99739.9873737374" "20170910" "99944.3718434343" "20170911" "99336.3554292929" "20170912" "100047.0662878788" "20170914" "99826.2771464647" "20170915" "100524.9981060606" "20170917" "101258.4785353535" "20170923" "102343.178030303" "20170924" "102575.4457070707" "20170925" "102531.2670454545" "20170928" "102607.9463383838" "20170929" "102463.154040404" "20170930" "101855.4002525253" "20171001" "101769.4450757576" "20171003" "101230.3238636364" "20171004" "101269.095959596" "20171005" "100313.1092171717" "20171008" "101425.817550505" "20171009" "101499.3005050505" "20171011" "100721.2506313131" "20171012" "101481.7746212121" "20171013" "101908.6508838384" "20171014" "102089.4223484848" "20171015" "102138.9678030303" "20171016" "101825.0555555556" "20171017" "101600.7967171717" "20171018" "101415.577020202" "20171019" "101419.5946969697" "20171020" "101053.2607323232" "20171021" "100992.7001262626" "20171022" "100745.2727272727" "20171023" "101830.4545454545" "20171024" "101919.6382575758" "20171025" "101660.0220959596" "20171026" "101708.0397727273" "20171027" "102081.033459596" "20171028" "101570.2853535353" "20171029" "100928.3781565657" "20171030" "102052.3207070707" "20171031" "102108.5751262626" "20171101" "101426.6003787879" "20171103" "101325.9027777778" "20171104" "100960.8428030303" "20171105" "100896.8522727273" "20171106" "102400.702020202" "20171109" "102069.779040404" "20171111" "100076.5391414141" "20171112" "100066.8958333333" "20171113" "101635.8333333333" "20171115" "102264.1628787879" "20171116" "102248.7752525253" "20171117" "102123.1773989899" "20171118" "101462.9053030303" "20171119" "100941.5599747475" "20171120" "101076.3876262626" "20171121" "100883.4191919192" "20171122" "100209.8920454545" "20171123" "100055.1079545455" "20171124" "100791.7733585859" "20171125" "100855.5422979798" "20171126" "100933.5258838384" "20171127" "101066.1306818182" "20171128" "99770.0763888889" "20171129" "100295.130050505" "20171130" "100623.5694444444" "20171201" "101932.8011363636" "20171202" "102187.1401515152" "20171203" "101811.1092171717" "20171204" "102227.1887626263" "20171205" "102282.4627525253" "20171206" "101943.639520202" "20171207" "101259.7588383838" "20171208" "99698.0372474747" "20171210" "99620.4065656566" "20171211" "98721.3023989899" "20171212" "100346.7904040404" "20171213" "100438.5511363636" "20171214" "98486.3358585859" "20171215" "99640.255050505" "20171216" "100802.9463383838" "20171217" "101753.0328282828" "20171219" "102895.2380050505" "20171220" "102963.4633838384" "20171222" "102858.033459596" "20171223" "102556.3371212121" "20171224" "101269.0063131313" "20171225" "100857.6919191919" "20171226" "99966.4109848485" "20171227" "99164.6275252525" "20171228" "99184.1256313131" "20171229" "99794.5404040404" "20171230" "99730.8598484848" "20171231" "99673.2089646465"} v ""))(defn enrich0toWF_ssr_2953481_+0_cumul1559467755356 "Enrichment - Date to WF_ssr_2953481_+0_cumul}" [v] (get {"20170101" "340759.2960858586" "20170102" "1939384.0498737374" "20170103" "436285.3724747475" "20170104" "1868207.4829545454" "20170105" "2127512.0460858587" "20170106" "1710337.2241161617" "20170107" "772344.0435606061" "20170108" "1658727.2676767677" "20170109" "1053271.8503787878" "20170110" "1529486.7582070706" "20170111" "1113194.8017676768" "20170112" "2196340.7657828284" "20170113" "1863139.19760101" "20170114" "2368322.1458333335" "20170115" "2412836.8636363638" "20170116" "2818376.9116161615" "20170117" "1948903.3099747475" "20170118" "740091.1022727273" "20170119" "1091447.5334595959" "20170120" "1269149.2196969697" "20170121" "1587027.0454545454" "20170122" "1748857.5858585858" "20170123" "2111635.512626263" "20170124" "2275676.210227273" "20170126" "2473527.0303030303" "20170127" "3659308.868686869" "20170128" "3495214.272727273" "20170129" "2034354.5953282828" "20170130" "1537822.7436868686" "20170131" "2470146.493686869" "20170201" "2836261.2196969697" "20170202" "2527499.342171717" "20170203" "1830516.6748737374" "20170204" "2864107.6792929294" "20170205" "1435801.2424242424" "20170206" "2998319.212752525" "20170207" "2452802.5441919193" "20170208" "2036883.5757575757" "20170209" "2251284.4545454546" "20170210" "2146814.1717171716" "20170211" "3392404.737373737" "20170212" "2821266.0404040404" "20170214" "6009959.151515151" "20170215" "6021616.575757576" "20170217" "4120676.121212121" "20170218" "3680326.222222222" "20170219" "3055352.4393939395" "20170220" "1624238.3358585858" "20170221" "6491080.6875" "20170222" "6380732.029671717" "20170223" "2283500.736111111" "20170227" "2360953.855429293" "20170302" "6353318.292929293" "20170304" "6013157.393939394" "20170305" "3927961.383838384" "20170306" "4260724.04040404" "20170307" "5050423.555555556" "20170310" "8587365.151515152" "20170312" "8887877.090909092" "20170315" "10755876.474747475" "20170318" "7873417.058712121" "20170319" "3324925.897727273" "20170320" "4664442.303030303" "20170323" "11819721.515151516" "20170331" "12431074.818181818" "20170402" "12018152.181818182" "20170403" "13663022.212121213" "20170405" "11709644.808080807" "20170412" "3577511.1717171716" "20170415" "11360770.232323233" "20170416" "15276589.191919193" "20170417" "16036735.929292928" "20170418" "17569505.2020202" "20170419" "17713579.767676767" "20170421" "11286336.454545455" "20170422" "17115742.78787879" "20170423" "17390887.727272727" "20170425" "16491428.606060605" "20170426" "19675586.666666668" "20170427" "14509265.363636363" "20170429" "17779179.09090909" "20170430" "21580086.83838384" "20170501" "20294765.020202022" "20170503" "17660453.626262628" "20170507" "18378943.242424242" "20170508" "18788211.393939395" "20170510" "9961062.858585859" "20170517" "11981652.676767677" "20170522" "22924095.191919193" "20170605" "21435046.939393938" "20170606" "18608908.060606062" "20170607" "12818796.555555556" "20170612" "20959977.21212121" "20170615" "20588111.545454547" "20170616" "22013034.222222224" "20170622" "16103995.373737374" "20170623" "11324586.484848484" "20170628" "14125734.757575758" "20170702" "17219858.626262628" "20170706" "24229148.70707071" "20170707" "16360572.424242424" "20170708" "20503571.979797978" "20170709" "24654498.727272727" "20170710" "13632648.121212121" "20170711" "19038235.888888888" "20170712" "11229968.949494949" "20170713" "21686337.83838384" "20170714" "17072642.646464646" "20170716" "10723404.868686868" "20170717" "20799724.282828283" "20170718" "21678436.323232323" "20170719" "20445254.2020202" "20170721" "17674639.646464646" "20170723" "10007227.616161617" "20170729" "13797622.474747475" "20170808" "16120861.828282828" "20170811" "13064163.1010101" "20170813" "17970375.83838384" "20170814" "19916882.686868686" "20170815" "15787603.161616161" "20170817" "9796110.030303031" "20170819" "15543933.1010101" "20170820" "15111714.464646464" "20170821" "16140170.565656565" "20170822" "14761832.404040404" "20170823" "17739051.95959596" "20170825" "16300371.868686868" "20170827" "14374464.161616161" "20170828" "15581078.676767677" "20170829" "17319841.03030303" "20170907" "7231648.575757576" "20170909" "5998128.686868687" "20170910" "11792386.212121213" "20170911" "9354044.777777778" "20170912" "11222630.686868686" "20170914" "6667664.161616161" "20170915" "10874875.222222222" "20170917" "11039295.424242424" "20170923" "10070669.141414141" "20170924" "8765542.767676767" "20170925" "8740118.686868686" "20170928" "8273950.303030303" "20170929" "8385754.4949494945" "20170930" "5642211.181818182" "20171001" "8422764.878156565" "20171003" "7741287.696969697" "20171004" "3202911.5353535353" "20171005" "3399680.571969697" "20171008" "8659062.141414141" "20171009" "6723529.575757576" "20171011" "2706146.797979798" "20171012" "6526810.545454546" "20171013" "6232912.919191919" "20171014" "3458230.606060606" "20171015" "6692814.202020202" "20171016" "6318200.96969697" "20171017" "7213977.808080808" "20171018" "3356983.3636363638" "20171019" "3920545.383838384" "20171020" "3707336.606060606" "20171021" "2984831.9494949495" "20171022" "3712208.360479798" "20171023" "4447973.78030303" "20171024" "1655794.8667929294" "20171025" "3388688.090909091" "20171026" "4167240.202020202" "20171027" "4583536.254419192" "20171028" "2226807.2095959596" "20171029" "5291929.82449495" "20171030" "4736062.747474748" "20171031" "2311811.8484848486" "20171101" "2582636.561237374" "20171103" "2933632.707070707" "20171104" "2650415.626262626" "20171105" "2577975.960227273" "20171106" "4575157.775883839" "20171109" "1341748.8333333333" "20171111" "3551172.470328283" "20171112" "2348052.455176768" "20171113" "3699910.7228535353" "20171115" "2994827.945075758" "20171116" "1215788.8465909092" "20171117" "3291322.3585858587" "20171118" "1902498.625" "20171119" "2965527.4892676766" "20171120" "2234059.6767676766" "20171121" "1626252.413510101" "20171122" "635565.7171717172" "20171123" "1617226.4936868686" "20171124" "1657001.1590909092" "20171125" "2167621.8491161615" "20171126" "1957067.6792929294" "20171127" "1062744.2777777778" "20171128" "1768504.9671717172" "20171129" "2051428.5441919193" "20171130" "1794629.6464646466" "20171201" "2015455.686868687" "20171202" "1736263.1553030303" "20171203" "1149243.821338384" "20171204" "2183749.1571969697" "20171205" "1176119.5460858585" "20171206" "713781.7228535353" "20171207" "669258.1262626263" "20171208" "1840475.1862373736" "20171210" "1498711.380050505" "20171211" "1357472.803030303" "20171212" "1342123.7190656567" "20171213" "876632.0069444445" "20171214" "1634104.9835858585" "20171215" "1332012.7626262626" "20171216" "2003832.115530303" "20171217" "2038732.1231060605" "20171219" "1023012.9974747475" "20171220" "750457.2361111111" "20171222" "1865533.3806818181" "20171223" "881682.7386363636" "20171224" "642466.851010101" "20171225" "892983.9406565657" "20171226" "1294899.4349747475" "20171227" "887994.8611111111" "20171228" "1561804.504419192" "20171229" "1863117.5271464647" "20171230" "625572.4753787878" "20171231" "508604.1805555556"} v ""))(defn enrich0toWF_tcc_2953481_+0_avg1559467755356 "Enrichment - Date to WF_tcc_2953481_+0_avg}" [v] (get {"20170101" "0.9528109727999999" "20170102" "0.4211180936142857" "20170103" "0.7913044661142857" "20170104" "0.44520644525714287" "20170105" "0.31348655887142857" "20170106" "0.7125831152714286" "20170107" "0.9135388904857143" "20170108" "0.8442711470285715" "20170109" "0.9248845754285714" "20170110" "0.7134525296285713" "20170111" "0.8433753829714287" "20170112" "0.6414066096285714" "20170113" "0.7331675187285714" "20170114" "0.45783087047142856" "20170115" "0.29103218285714283" "20170116" "0.055495048828571425" "20170117" "0.8168640327285714" "20170118" "0.9891332761285715" "20170119" "0.9096503980285713" "20170120" "0.8467391813571429" "20170121" "0.8697914905285715" "20170122" "0.9061870712571428" "20170123" "0.6996206748857142" "20170124" "0.6322089741571428" "20170126" "0.6191636122714286" "20170127" "0.28073741038571426" "20170128" "0.48836421554285714" "20170129" "0.7527349563000001" "20170130" "0.9734933540142856" "20170131" "0.8478670188714287" "20170201" "0.7218007077857143" "20170202" "0.6975338538142858" "20170203" "0.9793122225857143" "20170204" "0.8313016383857142" "20170205" "0.9927069669428573" "20170206" "0.8871676328571428" "20170207" "0.9013838164428571" "20170208" "0.9525717396857143" "20170209" "0.9390771378571429" "20170210" "0.8961682292714286" "20170211" "0.8421398784714286" "20170212" "0.9686273944142858" "20170214" "0.11494615342857144" "20170215" "0.05074595441428571" "20170217" "0.8202889327142858" "20170218" "0.8686880222" "20170219" "0.8984162301714285" "20170220" "0.9898899585714286" "20170221" "0.6711442537142858" "20170222" "0.42029126355714286" "20170223" "0.9011649628571429" "20170227" "0.9623613013428571" "20170302" "0.5812143500428572" "20170304" "0.9860313367571428" "20170305" "0.7709850888142856" "20170306" "0.9099712441142859" "20170307" "0.9273548630285714" "20170310" "0.5373907708571429" "20170312" "0.8207652875142858" "20170315" "0.3098296899" "20170318" "0.5256824416857143" "20170319" "0.8658533994428572" "20170320" "0.9462304982142858" "20170323" "0.5030050786857142" "20170331" "0.9169510570285714" "20170402" "0.4799222699285714" "20170403" "0.4031564071285714" "20170405" "0.5772090023714286" "20170412" "0.8987598974000001" "20170415" "0.7087939884571428" "20170416" "0.5734560803" "20170417" "0.5089459225" "20170418" "0.359332064" "20170419" "0.461808462" "20170421" "0.7424843968428572" "20170422" "0.3399945477142858" "20170423" "0.5518726205857142" "20170425" "0.48040434421428585" "20170426" "0.16838362172857144" "20170427" "0.5886566406" "20170429" "0.38269064987142853" "20170430" "0.15362273598571427" "20170501" "0.6149226006285715" "20170503" "0.7301987246" "20170507" "0.6153664244" "20170508" "0.5133170701571428" "20170510" "0.9931737946714285" "20170517" "0.7829926285714287" "20170522" "0.43983840745714275" "20170605" "0.4471343824142857" "20170606" "0.7837786083714287" "20170607" "0.8738987327142856" "20170612" "0.43103659477142847" "20170615" "0.7904799600571428" "20170616" "0.4023149058285714" "20170622" "0.9215454451714286" "20170623" "0.9873832302714287" "20170628" "0.9314991265" "20170702" "0.5599869337285714" "20170706" "0.5845435997142856" "20170707" "0.8404925562285713" "20170708" "0.46343733461428566" "20170709" "0.25547612178571427" "20170710" "0.8919701790857143" "20170711" "0.7890951212857142" "20170712" "0.8444537885571428" "20170713" "0.5524904664571428" "20170714" "0.7272096111428571" "20170716" "0.7162101916999999" "20170717" "0.38181285232857143" "20170718" "0.25924944635714287" "20170719" "0.5896671031285715" "20170721" "0.5986269954857141" "20170723" "0.7235391804285716" "20170729" "0.6957372239428571" "20170808" "0.9056099308285714" "20170811" "0.7328390425857142" "20170813" "0.3292626611428572" "20170814" "0.3843969274857143" "20170815" "0.741388299957143" "20170817" "0.8017424725285714" "20170819" "0.515409748" "20170820" "0.5097899596428571" "20170821" "0.5127348839285715" "20170822" "0.47549875758571425" "20170823" "0.3753575797" "20170825" "0.5474966250000001" "20170827" "0.5243097349999999" "20170828" "0.4436632516857143" "20170829" "0.3567783196142857" "20170907" "0.9178871426571427" "20170909" "0.8139947974999998" "20170910" "0.5854886937714285" "20170911" "0.7305116585142856" "20170912" "0.5166566770857143" "20170914" "0.8463909991857143" "20170915" "0.5600691371000001" "20170917" "0.5546294389285714" "20170923" "0.6242728415285714" "20170924" "0.5438486490571428" "20170925" "0.5445349068142857" "20170928" "0.7819217825285714" "20170929" "0.6906933643000001" "20170930" "0.8522081691571428" "20171001" "0.6598295842142857" "20171003" "0.5673802766" "20171004" "0.9501437900285713" "20171005" "0.7840046432000002" "20171008" "0.3954290577" "20171009" "0.599279918057143" "20171011" "0.9624618962857142" "20171012" "0.5720810441999999" "20171013" "0.8649571546857143" "20171014" "0.9617490562000001" "20171015" "0.4568675758142856" "20171016" "0.45284525552857147" "20171017" "0.4195094693571429" "20171018" "0.9070665323714285" "20171019" "0.9483148483857143" "20171020" "0.8110585053428572" "20171021" "0.7957502463285714" "20171022" "0.7297862832" "20171023" "0.7569321176571429" "20171024" "0.9820594069571428" "20171025" "0.7977205462571428" "20171026" "0.8512882647571428" "20171027" "0.7667524918142857" "20171028" "0.8729744530571428" "20171029" "0.4034058613" "20171030" "0.49106501412857145" "20171031" "0.920719251342857" "20171101" "0.9710765304000001" "20171103" "0.8112416319999999" "20171104" "0.8922478035714285" "20171105" "0.8252861794714287" "20171106" "0.2583609720857143" "20171109" "0.9167164332285713" "20171111" "0.39353352159999994" "20171112" "0.757058566457143" "20171113" "0.45619726460000004" "20171115" "0.7050545129285715" "20171116" "0.8921917895714288" "20171117" "0.4456011839571428" "20171118" "0.6986460460142857" "20171119" "0.47420096914285714" "20171120" "0.7898382067714287" "20171121" "0.9740659585142858" "20171122" "0.8268515913285714" "20171123" "0.6010702677571428" "20171124" "0.7297954621857142" "20171125" "0.6770515737428572" "20171126" "0.7094886960857144" "20171127" "0.8968041450285715" "20171128" "0.6633291570714285" "20171129" "0.6230861303142857" "20171130" "0.7814671867714286" "20171201" "0.5380555649142857" "20171202" "0.714363737842857" "20171203" "0.6904173103571428" "20171204" "0.4547934428142857" "20171205" "0.9111733391142857" "20171206" "0.9921419828285715" "20171207" "0.9608426444999998" "20171208" "0.6982418650142856" "20171210" "0.8868084207000001" "20171211" "0.9328656117142857" "20171212" "0.792837163" "20171213" "0.9145881757714286" "20171214" "0.7812333129000001" "20171215" "0.8058452455714286" "20171216" "0.4085581584" "20171217" "0.5254569996142857" "20171219" "0.881389567842857" "20171220" "0.9760658814857143" "20171222" "0.7286012969428571" "20171223" "0.9238275547" "20171224" "0.9659172472285713" "20171225" "0.9702465943571428" "20171226" "0.6318931122714285" "20171227" "0.9438642567714286" "20171228" "0.7236347327142857" "20171229" "0.5549032368142858" "20171230" "0.9560696782428572" "20171231" "0.9586973103142856"} v ""))(defn enrich0toWF_tcc_2953481_+0_min1559467755356 "Enrichment - Date to WF_tcc_2953481_+0_min}" [v] (get {"20170101" "0.733212866" "20170102" "0.1905443596" "20170103" "0.3890732274" "20170104" "0.3346440479" "20170105" "0.1636916652" "20170106" "0.5601840549" "20170107" "0.7026583104" "20170108" "0.6929796007" "20170109" "0.8704804378" "20170110" "0.4683532715" "20170111" "0.7658987334" "20170112" "0.4266252614" "20170113" "0.5111466225" "20170114" "0.2924971147" "20170115" "0.0158811627" "20170116" "0.0140479502" "20170117" "0.3574841432" "20170118" "0.9814302078" "20170119" "0.7508998062" "20170120" "0.5215484927" "20170121" "0.5570644803" "20170122" "0.8570633705" "20170123" "0.4108180807" "20170124" "0.5130686134" "20170126" "0.3461599639" "20170127" "0.0331781561" "20170128" "0.341518826" "20170129" "0.5434138751" "20170130" "0.8783159352" "20170131" "0.7636401244" "20170201" "0.4278666178" "20170202" "0.370154795" "20170203" "0.9511065242" "20170204" "0.6971065637" "20170205" "0.9606431813" "20170206" "0.7583336563" "20170207" "0.6757332554" "20170208" "0.9100677798" "20170209" "0.8730539649" "20170210" "0.5869436553" "20170211" "0.5716161246" "20170212" "0.9154129799" "20170214" "0.0270268604" "20170215" "0.0024657587" "20170217" "0.7054998224" "20170218" "0.6004808214" "20170219" "0.7357985371" "20170220" "0.9544843231" "20170221" "0.1870576492" "20170222" "0.0444681187" "20170223" "0.4692934595" "20170227" "0.9268906719" "20170302" "0.2575689759" "20170304" "0.9249751544" "20170305" "0.466041642" "20170306" "0.7138237231" "20170307" "0.8661892773" "20170310" "0.4311914926" "20170312" "0.709849348" "20170315" "0.0170214104" "20170318" "0.0582426437" "20170319" "0.2743545686" "20170320" "0.8144854921" "20170323" "0.0452951759" "20170331" "0.8417663574" "20170402" "0.2153144605" "20170403" "0.1832038032" "20170405" "0.0807004986" "20170412" "0.5638144137" "20170415" "0.5270031185" "20170416" "0.476780865" "20170417" "0.4512057755" "20170418" "0.0831795124" "20170419" "0.1332215589" "20170421" "0.2923583984" "20170422" "0.2235619131" "20170423" "0.3246006821" "20170425" "0.0661275844" "20170426" "0.0511533178" "20170427" "0.2688817496" "20170429" "0.1251085069" "20170430" "0.0155198839" "20170501" "0.4266301935" "20170503" "0.4469589975" "20170507" "0.4533673" "20170508" "0.2565424755" "20170510" "0.9730452721" "20170517" "0.3679233127" "20170522" "0.2710808648" "20170605" "0.2642541751" "20170606" "0.5236424918" "20170607" "0.701338951" "20170612" "0.2786375104" "20170615" "0.5369179466" "20170616" "0.3106045193" "20170622" "0.8546466249" "20170623" "0.96276054" "20170628" "0.8212640936" "20170702" "0.185666171" "20170706" "0.3735027891" "20170707" "0.7186143335" "20170708" "0.1580190948" "20170709" "0.0126429086" "20170710" "0.7152062618" "20170711" "0.7414950483" "20170712" "0.5296886147" "20170713" "0.3653225369" "20170714" "0.417973883" "20170716" "0.3189447342" "20170717" "0.0861797911" "20170718" "0.0757876309" "20170719" "0.1751527112" "20170721" "0.4107481061" "20170723" "0.2846785896" "20170729" "0.4860263401" "20170808" "0.8401202578" "20170811" "0.1562299632" "20170813" "0.1045199308" "20170814" "0.1015137952" "20170815" "0.4616067984" "20170817" "0.5542300618" "20170819" "0.4174075639" "20170820" "0.4625348948" "20170821" "0.3504588095" "20170822" "0.2300815775" "20170823" "0.1958275997" "20170825" "0.3382694745" "20170827" "0.3956571282" "20170828" "0.2191957416" "20170829" "0.225549563" "20170907" "0.8530076262" "20170909" "0.4977919696" "20170910" "0.517616349" "20170911" "0.5382543373" "20170912" "0.4182561726" "20170914" "0.6323204986" "20170915" "0.4781082125" "20170917" "0.4345999035" "20170923" "0.531850179" "20170924" "0.2367655436" "20170925" "0.4126346613" "20170928" "0.5905611102" "20170929" "0.5341482451" "20170930" "0.7730873185" "20171001" "0.4809154164" "20171003" "0.4175573798" "20171004" "0.6916147453" "20171005" "0.6259810157" "20171008" "0.2518628053" "20171009" "0.2910865244" "20171011" "0.9031867849" "20171012" "0.4168793649" "20171013" "0.5740014279" "20171014" "0.9203485046" "20171015" "0.0188144722" "20171016" "0.0961186573" "20171017" "0.1682292283" "20171018" "0.5367773807" "20171019" "0.8330031886" "20171020" "0.5697252678" "20171021" "0.6604292661" "20171022" "0.6041579297" "20171023" "0.644881176" "20171024" "0.9130172224" "20171025" "0.4562438504" "20171026" "0.374414978" "20171027" "0.4801059458" "20171028" "0.7563646388" "20171029" "0.1911355992" "20171030" "0.3178939049" "20171031" "0.7666219076" "20171101" "0.8600313972" "20171103" "0.6765990594" "20171104" "0.7566164779" "20171105" "0.6217155071" "20171106" "0.1590751879" "20171109" "0.7679674553" "20171111" "0.2227884182" "20171112" "0.4482440371" "20171113" "0.1858757867" "20171115" "0.4707219288" "20171116" "0.577597896" "20171117" "0.2694295247" "20171118" "0.450679552" "20171119" "0.3360775892" "20171120" "0.4353067417" "20171121" "0.9450320951" "20171122" "0.1327268042" "20171123" "0.2977606263" "20171124" "0.2870345018" "20171125" "0.2438524034" "20171126" "0.5852370394" "20171127" "0.6565454046" "20171128" "0.50363141" "20171129" "0.3916786269" "20171130" "0.7050833486" "20171201" "0.394347528" "20171202" "0.4998979665" "20171203" "0.3475244843" "20171204" "0.2904419562" "20171205" "0.7819893848" "20171206" "0.9718868371" "20171207" "0.8518978851" "20171208" "0.5853924872" "20171210" "0.6992073444" "20171211" "0.7655032734" "20171212" "0.4892556547" "20171213" "0.5352518101" "20171214" "0.6669813531" "20171215" "0.6905526378" "20171216" "0.2387152778" "20171217" "0.2335784604" "20171219" "0.8399916387" "20171220" "0.8993798103" "20171222" "0.5084848787" "20171223" "0.7072338998" "20171224" "0.9284052987" "20171225" "0.8840988622" "20171226" "0.3696904727" "20171227" "0.6653053977" "20171228" "0.6115833718" "20171229" "0.3654547797" "20171230" "0.7967106983" "20171231" "0.8050226477"} v ""))(defn enrich0toWF_tcc_2953481_+0_max1559467755356 "Enrichment - Date to WF_tcc_2953481_+0_max}" [v] (get {"20170101" "1" "20170102" "0.572587755" "20170103" "0.9998221349" "20170104" "0.6029126716" "20170105" "0.4337438718" "20170106" "0.9847489174" "20170107" "0.9996183761" "20170108" "0.9442762823" "20170109" "0.9987987172" "20170110" "0.9929528628" "20170111" "0.9722286956" "20170112" "0.9325728127" "20170113" "0.9999927878" "20170114" "0.644779398" "20170115" "0.4562803326" "20170116" "0.1144415345" "20170117" "0.9588308623" "20170118" "0.9971184008" "20170119" "0.9974423803" "20170120" "0.9939753985" "20170121" "0.9733359597" "20170122" "0.9653967655" "20170123" "0.9360027891" "20170124" "0.7429307109" "20170126" "0.9327463478" "20170127" "0.563051166" "20170128" "0.7085861052" "20170129" "0.9394870334" "20170130" "1" "20170131" "0.9434539549" "20170201" "0.8944122623" "20170202" "0.9722379434" "20170203" "0.9996244388" "20170204" "0.9999704072" "20170205" "0.9996103614" "20170206" "0.9760594976" "20170207" "0.9845227641" "20170208" "0.9813750296" "20170209" "0.9982225823" "20170210" "0.9956433845" "20170211" "0.9946957983" "20170212" "0.9917376149" "20170214" "0.2497980908" "20170215" "0.1115670252" "20170217" "0.9656245684" "20170218" "0.9811278663" "20170219" "0.9906446669" "20170220" "0.9999957494" "20170221" "0.9946302808" "20170222" "0.9999939203" "20170223" "0.9999106051" "20170227" "0.9966332021" "20170302" "0.8601351651" "20170304" "0.9996979327" "20170305" "0.9961504695" "20170306" "0.9935943912" "20170307" "0.9699773629" "20170310" "0.6305612892" "20170312" "0.8817311297" "20170315" "0.753933685" "20170318" "0.9898819351" "20170319" "0.999717117" "20170320" "0.9999505071" "20170323" "0.8982503872" "20170331" "0.9723600137" "20170402" "0.7866973595" "20170403" "0.6394120033" "20170405" "0.9020015832" "20170412" "1" "20170415" "0.9450856754" "20170416" "0.7201501095" "20170417" "0.6383454294" "20170418" "0.70307013" "20170419" "0.6947940094" "20170421" "0.9592852352" "20170422" "0.5440895774" "20170423" "0.6486492735" "20170425" "0.7945908055" "20170426" "0.2634292757" "20170427" "0.7185591431" "20170429" "0.6007194134" "20170430" "0.345729327" "20170501" "0.8460899892" "20170503" "0.9509631841" "20170507" "0.8481374775" "20170508" "0.9173140612" "20170510" "0.9998427882" "20170517" "0.9967595881" "20170522" "0.6763811456" "20170605" "0.5926677049" "20170606" "0.9590830177" "20170607" "0.9840843124" "20170612" "0.6861190025" "20170615" "0.9414343015" "20170616" "0.5656383784" "20170622" "0.9642661648" "20170623" "0.9994056779" "20170628" "0.992382011" "20170702" "0.8913479267" "20170706" "0.9112379286" "20170707" "0.9353566796" "20170708" "0.9568795869" "20170709" "0.5018165665" "20170710" "0.999682669" "20170711" "0.8725907536" "20170712" "0.9942386951" "20170713" "0.8199552286" "20170714" "0.928727819" "20170716" "0.9867519353" "20170717" "0.799171456" "20170718" "0.4926847207" "20170719" "0.8986767391" "20170721" "0.7760848976" "20170723" "0.9991591545" "20170729" "0.8940065606" "20170808" "0.97637048" "20170811" "0.927659221" "20170813" "0.4832380588" "20170814" "0.6260487675" "20170815" "0.9077235726" "20170817" "0.9971829095" "20170819" "0.7344292535" "20170820" "0.5640661252" "20170821" "0.7405722618" "20170822" "0.6696798922" "20170823" "0.4972460198" "20170825" "0.7283938629" "20170827" "0.6037520549" "20170828" "0.6836973248" "20170829" "0.5768296984" "20170907" "0.9862952432" "20170909" "0.999329188" "20170910" "0.6698513247" "20170911" "0.9025468923" "20170912" "0.5981109582" "20170914" "0.9468285874" "20170915" "0.6324116907" "20170917" "0.6751499369" "20170923" "0.6825071393" "20170924" "0.8826926291" "20170925" "0.7236661044" "20170928" "0.9156149169" "20170929" "0.9699623801" "20170930" "0.9735051935" "20171001" "0.8339717364" "20171003" "0.9022456839" "20171004" "0.9969718743" "20171005" "0.9998230597" "20171008" "0.5094291858" "20171009" "0.6965223083" "20171011" "0.9950142292" "20171012" "0.8567276772" "20171013" "0.9913265344" "20171014" "0.9994069109" "20171015" "0.9446978328" "20171016" "0.7489466812" "20171017" "0.5525857945" "20171018" "0.994296912" "20171019" "0.9852365821" "20171020" "0.9717098219" "20171021" "0.9441458862" "20171022" "0.9029835649" "20171023" "0.8772275315" "20171024" "0.9991668553" "20171025" "0.984179118" "20171026" "0.9893917821" "20171027" "0.9984947074" "20171028" "0.9997268656" "20171029" "0.7404079082" "20171030" "0.7618956903" "20171031" "0.9976057573" "20171101" "0.9996938994" "20171103" "0.9103163509" "20171104" "0.9899012466" "20171105" "0.9777234507" "20171106" "0.4099716032" "20171109" "0.9977011739" "20171111" "0.526781091" "20171112" "0.9952680673" "20171113" "0.7148883465" "20171115" "0.9352034752" "20171116" "0.9946671303" "20171117" "0.7197587326" "20171118" "0.9235575669" "20171119" "0.7129229644" "20171120" "0.9857268839" "20171121" "0.9997718034" "20171122" "0.9996016826" "20171123" "0.8834467226" "20171124" "0.9757844559" "20171125" "0.7868922576" "20171126" "0.8629606349" "20171127" "0.9901030569" "20171128" "0.9446012835" "20171129" "0.7817401308" "20171130" "0.8740663359" "20171201" "0.6626474534" "20171202" "0.9295474667" "20171203" "0.9910888672" "20171204" "0.6954706713" "20171205" "0.9980974303" "20171206" "0.9986410451" "20171207" "0.9949584344" "20171208" "0.8297355864" "20171210" "0.9995916877" "20171211" "0.99999678" "20171212" "0.975560225" "20171213" "0.994953409" "20171214" "0.9998181276" "20171215" "0.9708280172" "20171216" "0.668285158" "20171217" "0.9039674879" "20171219" "0.9584235079" "20171220" "0.9999126822" "20171222" "0.9582810926" "20171223" "0.9973889824" "20171224" "0.9997623218" "20171225" "0.9999183115" "20171226" "0.8640401821" "20171227" "0.999421006" "20171228" "0.9370223605" "20171229" "0.8145650228" "20171230" "0.9999654419" "20171231" "0.9997061657"} v ""))(defn enrich0toWF_tp_2953481_+0_cumul1559467755356 "Enrichment - Date to WF_tp_2953481_+0_cumul}" [v] (get {"20170101" "0.0069800242" "20170102" "0.0010577043" "20170103" "0.005323386" "20170104" "0.0019318101" "20170105" "0.0002666579" "20170106" "0.0005238598" "20170107" "0.0027165702" "20170108" "0.0001723935" "20170109" "0.0014886736" "20170110" "0.0022112697" "20170111" "0.0072835245" "20170112" "0.00127001" "20170113" "0.0017929462" "20170114" "0.0013164896" "20170115" "0.0005598923" "20170116" "0.000002442" "20170117" "0.0000547929" "20170118" "0.0008549034" "20170119" "0.0005509793" "20170120" "0.0003180164" "20170121" "0.0002838855" "20170122" "0.0003104788" "20170123" "0.0002627511" "20170124" "0.0000623525" "20170128" "0.0000118806" "20170129" "0.001681836" "20170130" "0.0062319775" "20170131" "0.0001813234" "20170201" "0.0001986075" "20170202" "0.000354296" "20170203" "0.0020509164" "20170204" "0.0014930976" "20170205" "0.0017450121" "20170206" "0.0014422807" "20170207" "0.0015006378" "20170208" "0.0015493463" "20170209" "0.0006489371" "20170210" "0.0002980365" "20170211" "0.0004521958" "20170212" "0.0001610108" "20170215" "0.0000015922" "20170217" "0.0006188505" "20170218" "0.0002226492" "20170219" "0.0043852233" "20170220" "0.0031608909" "20170221" "0.0001349064" "20170222" "0.006822037" "20170223" "0.0124748307" "20170227" "0.005190016" "20170302" "0.0018384144" "20170304" "0.0018286825" "20170305" "0.0040049697" "20170306" "0.0008034032" "20170307" "0.0003054166" "20170310" "0.0000338506" "20170312" "0.0000251917" "20170318" "0.006275132" "20170319" "0.0093548049" "20170320" "0.0078509986" "20170331" "0.0000758611" "20170402" "0.0013329622" "20170403" "0.0000451454" "20170405" "0.0003922275" "20170412" "0.0067891545" "20170415" "0.0071133652" "20170416" "0.0014049177" "20170417" "0.0021574907" "20170418" "0.0005753835" "20170419" "0.0000735485" "20170421" "0.0009816126" "20170422" "0.0006265881" "20170423" "0.0004948341" "20170425" "0.0017319496" "20170426" "0.0008193748" "20170427" "0.0021121671" "20170429" "0.0019547096" "20170503" "0.0000694641" "20170507" "0.0001820506" "20170508" "0.0007581614" "20170510" "0.003539726" "20170517" "0.0010625341" "20170522" "0.0000040868" "20170605" "0.0003482934" "20170606" "0.0036062761" "20170607" "0.0103811158" "20170612" "0.0018573024" "20170615" "0.0011797385" "20170616" "0.0028835884" "20170622" "0.0075015347" "20170623" "0.0033673758" "20170628" "0.0071238604" "20170702" "0.0006276333" "20170706" "0.0000445506" "20170707" "0.0026607417" "20170708" "0.0014949929" "20170709" "0.0000012427" "20170710" "0.0018703865" "20170711" "0.0019255311" "20170712" "0.0090245237" "20170713" "0.000121567" "20170714" "0.0021491918" "20170716" "0.0036803496" "20170717" "0.0000725973" "20170718" "0.0000487843" "20170719" "0.0003286853" "20170721" "0.0019041505" "20170723" "0.0145944827" "20170729" "0.0063782991" "20170808" "0.0025395047" "20170811" "0.0003382365" "20170813" "0.0002779575" "20170815" "0.0047788764" "20170817" "0.0050846928" "20170819" "0.0039537892" "20170820" "0.0059535431" "20170821" "0.0024482168" "20170822" "0.001370796" "20170823" "0.000173706" "20170825" "0.0002843491" "20170827" "0.0028161328" "20170828" "0.0001271373" "20170829" "0.0000601444" "20170907" "0.0047308893" "20170909" "0.0073545822" "20170910" "0.0019189565" "20170911" "0.0080224673" "20170912" "0.0035070554" "20170914" "0.0132499196" "20170915" "0.005618158" "20170917" "0.0038705257" "20170923" "0.0003181852" "20170924" "0.0004755463" "20170925" "0.0008092697" "20170928" "0.0004886136" "20170929" "0.0020388449" "20170930" "0.0105513563" "20171001" "0.001376311" "20171003" "0.0022238144" "20171004" "0.0058787447" "20171005" "0.0184342644" "20171008" "0.0001729956" "20171009" "0.0019119147" "20171011" "0.0032753198" "20171012" "0.0041425156" "20171013" "0.0001844147" "20171014" "0.0006883427" "20171015" "0.000064735" "20171016" "0.0000256052" "20171017" "0.0000102556" "20171018" "0.0023820701" "20171019" "0.0026327889" "20171020" "0.0050961634" "20171021" "0.0045632256" "20171022" "0.0054844521" "20171023" "0.001707655" "20171024" "0.0059474165" "20171025" "0.0042116377" "20171026" "0.0004393163" "20171027" "0.0019119532" "20171028" "0.0022777596" "20171029" "0.0037592184" "20171030" "0.0006591912" "20171031" "0.0014201294" "20171101" "0.0015376288" "20171103" "0.0006747246" "20171104" "0.001308682" "20171105" "0.0020647434" "20171106" "0.000326224" "20171109" "0.0018798859" "20171111" "0.0028900378" "20171112" "0.0048883419" "20171113" "0.0004197082" "20171115" "0.0002574054" "20171116" "0.0029541989" "20171117" "0.000385173" "20171118" "0.0093083189" "20171119" "0.0049057826" "20171120" "0.0011569755" "20171121" "0.0024974948" "20171122" "0.0080237629" "20171123" "0.0017794599" "20171124" "0.0023061097" "20171125" "0.001853442" "20171126" "0.0043032988" "20171127" "0.0091414741" "20171128" "0.0045368262" "20171129" "0.0019832476" "20171130" "0.0035084281" "20171201" "0.0006446598" "20171202" "0.0013559479" "20171203" "0.0030483092" "20171204" "0.0004362" "20171205" "0.0006228914" "20171206" "0.0021405509" "20171207" "0.0041184329" "20171208" "0.0027463942" "20171210" "0.0051590286" "20171211" "0.0023416558" "20171212" "0.0028627617" "20171213" "0.0065170876" "20171214" "0.0057197654" "20171215" "0.00251705" "20171216" "0.0018749333" "20171217" "0.0010330894" "20171219" "0.0006296839" "20171220" "0.0006301331" "20171222" "0.0000370512" "20171223" "0.0006589095" "20171224" "0.0016492232" "20171225" "0.0018164642" "20171226" "0.0029197365" "20171227" "0.0073706405" "20171228" "0.0010872369" "20171229" "0.0017373755" "20171230" "0.0058607337" "20171231" "0.0079025981"} v ""))(defn enrich0toWF_vis_2953481_+0_avg1559467755356 "Enrichment - Date to WF_vis_2953481_+0_avg}" [v] (get {"20170101" "15300.184393526313" "20170102" "26893.479107503084" "20170103" "15781.763110404412" "20170104" "25850.9100724918" "20170105" "27290.550042706986" "20170106" "25934.716003506044" "20170107" "20195.294783026628" "20170108" "24813.44684974043" "20170109" "20733.856566986484" "20170110" "21590.706290196886" "20170111" "18446.73712122976" "20170112" "23997.742413563476" "20170113" "21131.38190135433" "20170114" "23726.78031190376" "20170115" "24734.239492088855" "20170116" "25315.068813968013" "20170117" "25419.74952946563" "20170118" "20241.946205106145" "20170119" "20392.539817446766" "20170120" "22486.53768057776" "20170121" "22642.040927991588" "20170122" "22691.68616244493" "20170123" "24263.652594452116" "20170124" "24239.576353329085" "20170126" "25989.02927796114" "20170127" "26288.565590642414" "20170128" "26199.605839893058" "20170129" "21783.396158854168" "20170130" "12979.146427501355" "20170131" "24632.676894701228" "20170201" "24756.440790217668" "20170202" "24536.64061255956" "20170203" "18761.932976550685" "20170204" "20691.301874422228" "20170205" "16931.24479369234" "20170206" "22880.259638094114" "20170207" "24707.81567924467" "20170208" "24833.37969856207" "20170209" "25958.645913788776" "20170210" "25328.325207532736" "20170211" "26045.673168870446" "20170212" "26617.297338796732" "20170214" "28418.547354385788" "20170215" "28266.2155710636" "20170217" "24189.605020784544" "20170218" "22950.51914229401" "20170219" "19351.791409204885" "20170220" "16201.677529052915" "20170221" "24183.778943544872" "20170222" "19686.89656324509" "20170223" "12526.270244824058" "20170227" "13577.600120203144" "20170302" "19292.15386923256" "20170304" "19597.867499523512" "20170305" "16521.0120356616" "20170306" "18028.783556499187" "20170307" "19383.141812477283" "20170310" "19452.600725666627" "20170312" "19109.670980103958" "20170315" "18465.528092971956" "20170318" "13340.162309126415" "20170319" "9726.011444840402" "20170320" "10796.755246535355" "20170323" "18002.090349954273" "20170331" "18885.84845032354" "20170402" "17411.61784477288" "20170403" "18266.20134831987" "20170405" "18790.377531219532" "20170412" "10268.294895100542" "20170415" "13327.296024713329" "20170416" "18401.526173799415" "20170417" "18067.931020981658" "20170418" "19684.927973495414" "20170419" "20508.890935372143" "20170421" "18048.662286579514" "20170422" "19877.924163950487" "20170423" "20159.95128846271" "20170425" "19003.663738828713" "20170426" "20202.16950246749" "20170427" "16740.927678910513" "20170429" "19483.072031965166" "20170430" "21187.820823680457" "20170501" "21225.99631602629" "20170503" "21428.663303193585" "20170507" "20940.5418097646" "20170508" "20083.765386209856" "20170510" "13666.635819340187" "20170517" "21040.317638578876" "20170522" "20209.207418994985" "20170605" "20606.080935941973" "20170606" "18790.02260676573" "20170607" "11307.071107102016" "20170612" "18534.269749915275" "20170615" "19588.540438411197" "20170616" "18860.86566945966" "20170622" "18585.088361643757" "20170623" "16689.993275652032" "20170628" "15857.1965679923" "20170702" "19733.769385906187" "20170706" "21507.20311830639" "20170707" "19491.8281185486" "20170708" "19808.65401831953" "20170709" "21592.12572268973" "20170710" "19903.794798065243" "20170711" "19710.125953046787" "20170712" "21859.075401295144" "20170713" "37085.2408782827" "20170714" "32233.457396205897" "20170716" "21765.5859297495" "20170717" "34961.99785877134" "20170718" "33098.759189974524" "20170719" "30694.708752212387" "20170721" "28810.034611843712" "20170723" "19903.718321256656" "20170729" "24583.04044620577" "20170808" "29256.158762437783" "20170811" "31503.442259685304" "20170813" "35523.017983506754" "20170814" "36477.47822700709" "20170815" "28929.386460143258" "20170817" "22255.338863290257" "20170819" "29086.407693662" "20170820" "26155.082933830487" "20170821" "30336.906105206643" "20170822" "33542.89242736463" "20170823" "33338.53891200386" "20170825" "32314.528599902842" "20170827" "29872.50422355797" "20170828" "30874.33509817853" "20170829" "31951.868296943856" "20170907" "24251.617231492866" "20170909" "19968.973243262" "20170910" "30079.635681989042" "20170911" "22906.72756108094" "20170912" "28317.572046915673" "20170914" "17917.288641969528" "20170915" "27533.14075435844" "20170917" "28768.58550036763" "20170923" "30001.328929020383" "20170924" "29000.105570144984" "20170925" "29481.383445552587" "20170928" "33574.74341434627" "20170929" "29877.33872052256" "20170930" "23610.400742325783" "20171001" "34197.90275047488" "20171003" "33444.95920911737" "20171004" "24784.53058015457" "20171005" "24263.121085515097" "20171008" "44393.60818274471" "20171009" "36734.6038340779" "20171011" "23013.4566614941" "20171012" "37067.42955193237" "20171013" "37157.11047997413" "20171014" "28594.81616633691" "20171015" "33948.53076971143" "20171016" "34443.56579981773" "20171017" "44311.108968891625" "20171018" "29916.751579824115" "20171019" "29262.63364032233" "20171020" "25793.948771423085" "20171021" "26273.8708122881" "20171022" "27161.810923963025" "20171023" "33025.23949682281" "20171024" "22904.50312338384" "20171025" "32040.12039164754" "20171026" "40641.14232863388" "20171027" "42405.21538540397" "20171028" "29635.742503222627" "20171029" "41858.91221645075" "20171030" "50496.4933530689" "20171031" "34317.06355323076" "20171101" "29137.217211900857" "20171103" "38316.29802834869" "20171104" "33796.90089273384" "20171105" "34527.48349677193" "20171106" "46264.300183338884" "20171109" "33051.82096935454" "20171111" "43492.81765500464" "20171112" "35070.62307532283" "20171113" "45936.22323280323" "20171115" "38290.231189392" "20171116" "24243.0555301903" "20171117" "45609.08572731183" "20171118" "31225.537631520627" "20171119" "39461.38438270207" "20171120" "40657.35763027969" "20171121" "25561.54994084963" "20171122" "24323.322073624087" "20171123" "43411.63699087605" "20171124" "38121.25555730383" "20171125" "41662.70013546633" "20171126" "35345.2315388469" "20171127" "19969.878657155212" "20171128" "29580.4899844215" "20171129" "30846.64087457919" "20171130" "30412.230110884062" "20171201" "41691.77331333794" "20171202" "34802.83636443784" "20171203" "33617.683162782785" "20171204" "46273.52294142423" "20171205" "38668.54279070878" "20171206" "32987.93370831201" "20171207" "32292.134503737518" "20171208" "43911.151865795415" "20171210" "31101.626071329945" "20171211" "33718.33514311819" "20171212" "37425.725786833886" "20171213" "22642.446646355984" "20171214" "33744.11340952951" "20171215" "34378.18033675817" "20171216" "45886.278354793416" "20171217" "44529.60629164568" "20171219" "33509.53275423476" "20171220" "23649.02088802717" "20171222" "44402.19844240133" "20171223" "31866.120975554953" "20171224" "27846.337335649845" "20171225" "28001.638114323683" "20171226" "36428.33881154687" "20171227" "23068.80492252499" "20171228" "39546.41312524044" "20171229" "38665.54961207007" "20171230" "18909.186173057846" "20171231" "21998.82098071607"} v ""))(defn enrich0toWF_vis_2953481_+0_min1559467755356 "Enrichment - Date to WF_vis_2953481_+0_min}" [v] (get {"20170101" "3933.7721970683" "20170102" "23866.3624298404" "20170103" "5873.1607481061" "20170104" "24217.1641249223" "20170105" "26977.2920809659" "20170106" "21963.8947704585" "20170107" "12688.5438762626" "20170108" "22950.8003909949" "20170109" "13813.6176494252" "20170110" "13699.180511937" "20170111" "11256.3903142756" "20170112" "22144.0241999771" "20170113" "17168.2478109032" "20170114" "22707.6177078401" "20170115" "23211.310290404" "20170116" "25262.499315204" "20170117" "25120.4678295405" "20170118" "18638.5879103535" "20170119" "17276.2356783164" "20170120" "20091.6824046434" "20170121" "20137.1206104009" "20170122" "20678.5043543035" "20170123" "22573.0199823861" "20170124" "21857.4017104332" "20170126" "25283.6836688109" "20170127" "26270.5592418632" "20170128" "25516.0109296086" "20170129" "15880.9263493702" "20170130" "7712.2223418265" "20170131" "21524.7245326187" "20170201" "21296.4890124388" "20170202" "21160.8084798485" "20170203" "14560.7982476745" "20170204" "14852.4037524907" "20170205" "14990.7295960706" "20170206" "18825.1682350852" "20170207" "23737.4834511497" "20170208" "24010.8101723411" "20170209" "24907.006707702" "20170210" "24644.4455541746" "20170211" "24468.9888310288" "20170212" "24971.5779822764" "20170214" "27592.0949372571" "20170215" "27925.9941998106" "20170217" "20978.4094242905" "20170218" "17063.582012138" "20170219" "10399.6482226439" "20170220" "12477.7683134753" "20170221" "21495.4031758935" "20170222" "4699.341254032" "20170223" "2941.904315987" "20170227" "9051.4273126776" "20170302" "17098.460808648" "20170304" "13548.5080837674" "20170305" "7448.6636753275" "20170306" "17297.0314724084" "20170307" "19003.136524239" "20170310" "19127.1847290656" "20170312" "19056.428543245" "20170315" "18380.8913278291" "20170318" "4865.7335513336" "20170319" "4964.3787875705" "20170320" "3045.2175491795" "20170323" "15310.3301212812" "20170331" "18657.5419823232" "20170402" "13572.5198502974" "20170403" "17488.7244429155" "20170405" "18372.55881323" "20170412" "3579.2982905224" "20170415" "10947.876230105" "20170416" "14543.3546779132" "20170417" "16955.0035947549" "20170418" "16370.1434580485" "20170419" "20366.6876972854" "20170421" "11495.9138208254" "20170422" "19284.9026105476" "20170423" "18371.8578608349" "20170425" "15688.2455963751" "20170426" "18753.8191922891" "20170427" "15135.2085925786" "20170429" "17147.6180709685" "20170430" "21163.7381554806" "20170501" "21144.5502995963" "20170503" "20721.3353125062" "20170507" "18467.8749938348" "20170508" "16022.593817971" "20170510" "9362.960493608" "20170517" "16184.439931542" "20170522" "14371.9383309104" "20170605" "18815.3314098011" "20170606" "15662.2922531282" "20170607" "8602.5530574298" "20170612" "12614.3824327257" "20170615" "17403.2183998185" "20170616" "17821.6888982599" "20170622" "16038.6484153054" "20170623" "13064.0228374751" "20170628" "10570.1817593045" "20170702" "16761.4308884746" "20170706" "21488.9245506826" "20170707" "16660.5041158657" "20170708" "17583.9344818423" "20170709" "21572.2200249566" "20170710" "17224.9742320668" "20170711" "18332.9191239482" "20170712" "10736.8497228141" "20170713" "34438.3344342781" "20170714" "29462.5166829427" "20170716" "15881.6898896188" "20170717" "31562.841409086" "20170718" "30266.2225206163" "20170719" "26297.1735938486" "20170721" "16555.6673563948" "20170723" "9103.0554115989" "20170729" "12910.5986402107" "20170808" "17377.5162011349" "20170811" "29774.7690415816" "20170813" "27583.5287484834" "20170814" "34505.8190873271" "20170815" "21184.6452562737" "20170817" "13061.0024709991" "20170819" "22014.2784483939" "20170820" "22633.010022096" "20170821" "20663.7503871725" "20170822" "31005.9796304414" "20170823" "27137.4782069042" "20170825" "27007.9450939448" "20170827" "24088.8555789524" "20170828" "25028.0616271664" "20170829" "29692.4030934343" "20170907" "21187.4726883089" "20170909" "10542.4425455729" "20170910" "28485.891334919" "20170911" "17428.5462245748" "20170912" "26989.4089503433" "20170914" "6074.5500286372" "20170915" "24176.4221117424" "20170917" "22536.7071832214" "20170923" "22559.3899635931" "20170924" "25746.6653954092" "20170925" "25377.1446909278" "20170928" "32414.844745058" "20170929" "26052.4285252118" "20170930" "18016.0781362514" "20171001" "28201.9220161823" "20171003" "28660.325088501" "20171004" "10861.4149502841" "20171005" "5443.4138920331" "20171008" "37609.5490121552" "20171009" "26585.1521554041" "20171011" "20174.9660743174" "20171012" "24399.5051939993" "20171013" "28971.0804874921" "20171014" "24840.8248673256" "20171015" "26564.0261438543" "20171016" "31909.3551831486" "20171017" "39303.4262760047" "20171018" "20060.7281928785" "20171019" "19125.5350665468" "20171020" "18185.7807000671" "20171021" "22945.6457420889" "20171022" "20386.0357388583" "20171023" "26140.2864732839" "20171024" "14342.1462539519" "20171025" "18457.4593655365" "20171026" "36012.6340449169" "20171027" "34190.2306328976" "20171028" "17573.6884329439" "20171029" "15535.5375822433" "20171030" "48959.3596931226" "20171031" "18775.8222804214" "20171101" "21145.2824115175" "20171103" "29682.84190307" "20171104" "24770.1911235771" "20171105" "27779.4440259837" "20171106" "39389.9165526111" "20171109" "22000.7382294626" "20171111" "36837.3958012745" "20171112" "25719.1472747494" "20171113" "42049.4153422346" "20171115" "34836.8840997869" "20171116" "20419.1444500239" "20171117" "36792.343207157" "20171118" "16366.8998496316" "20171119" "35221.5962658506" "20171120" "33413.9227845163" "20171121" "17506.6781076759" "20171122" "9676.3925083045" "20171123" "36712.9870358862" "20171124" "31833.2126390862" "20171125" "38675.353240042" "20171126" "30366.1956611402" "20171127" "12356.4783519398" "20171128" "13814.2060346507" "20171129" "24550.5314220082" "20171130" "23689.1079736575" "20171201" "35999.6518641" "20171202" "20478.1451271134" "20171203" "16393.5125374842" "20171204" "38656.5150454743" "20171205" "32793.7130917636" "20171206" "29536.469469475" "20171207" "16552.8785166114" "20171208" "41152.9439832899" "20171210" "24573.1908785117" "20171211" "11825.9220044685" "20171212" "15754.5157535437" "20171213" "7672.0365136657" "20171214" "9438.249000164" "20171215" "30208.3599312522" "20171216" "40776.43041052" "20171217" "28573.2929786143" "20171219" "28383.783642239" "20171220" "17687.7218578608" "20171222" "35945.4397371851" "20171223" "27102.2415674383" "20171224" "22956.8219092783" "20171225" "18537.5086998217" "20171226" "30860.0222864633" "20171227" "15644.6336175167" "20171228" "32301.0575768057" "20171229" "32388.4223657473" "20171230" "6621.7504646995" "20171231" "7516.587409742"} v ""))(defn enrich0toWF_vis_2953481_+0_max1559467755356 "Enrichment - Date to WF_vis_2953481_+0_max}" [v] (get {"20170101" "27942.5667712279" "20170102" "28120.4940691091" "20170103" "26325.5798725167" "20170104" "26956.3192027699" "20170105" "27615.4126642401" "20170106" "27638.8671554411" "20170107" "25010.2907512935" "20170108" "26328.906387175" "20170109" "23449.4964853923" "20170110" "24988.9844166149" "20170111" "23870.4857908307" "20170112" "24869.4030804875" "20170113" "23734.5006123552" "20170114" "24529.681492661" "20170115" "25303.4762345131" "20170116" "25373.7673682011" "20170117" "25575.2030033921" "20170118" "23063.068235301" "20170119" "23261.9976325758" "20170120" "24924.768056542" "20170121" "25351.2683510829" "20170122" "24138.447561553" "20170123" "25753.3600453078" "20170124" "25288.8978809395" "20170126" "26301.4418008207" "20170127" "26310.1933001894" "20170128" "26327.1290591461" "20170129" "26076.039826056" "20170130" "23229.8660380046" "20170131" "25891.5861024182" "20170201" "26610.7125626381" "20170202" "26457.2830722693" "20170203" "22945.8730749265" "20170204" "24066.9595984257" "20170205" "20417.0935033933" "20170206" "25192.128432611" "20170207" "26466.7571830364" "20170208" "26170.9293447167" "20170209" "26798.6301261825" "20170210" "26520.2282320273" "20170211" "27453.1897626164" "20170212" "27426.4538352273" "20170214" "28639.4701309975" "20170215" "28460.2359386406" "20170217" "25774.7500073982" "20170218" "25890.7591787011" "20170219" "24477.1608595415" "20170220" "22671.076264969" "20170221" "25010.5401571255" "20170222" "24319.1261965048" "20170223" "23788.0902384748" "20170227" "17775.2252258917" "20170302" "21045.8376292219" "20170304" "20909.097103851" "20170305" "20153.9913459547" "20170306" "18660.7235129" "20170307" "19726.6722029869" "20170310" "19606.0295286853" "20170312" "19194.5645217125" "20170315" "18541.8084235914" "20170318" "18085.6033631912" "20170319" "18116.9817122642" "20170320" "15961.5689136235" "20170323" "18694.9536083491" "20170331" "18957.1492660985" "20170402" "18894.6702572601" "20170403" "19059.6524858571" "20170405" "19320.1136782868" "20170412" "18503.1524843158" "20170415" "15648.3865140664" "20170416" "19542.3254910864" "20170417" "18887.0905747847" "20170418" "20501.7684856376" "20170419" "20602.5307074653" "20170421" "20379.9491151752" "20170422" "20448.0133364899" "20170423" "20604.7054800939" "20170425" "20571.9888724895" "20170426" "20779.2776258064" "20170427" "19987.5738637905" "20170429" "21142.4163904672" "20170430" "21204.2337436869" "20170501" "21285.1858300103" "20170503" "21604.0164611508" "20170507" "21605.8066958032" "20170508" "21910.8760209517" "20170510" "18157.3989331795" "20170517" "22491.1450047348" "20170522" "22097.4915561869" "20170605" "21046.6556692412" "20170606" "20942.2017805311" "20170607" "12814.500575056" "20170612" "20149.4090087582" "20170615" "20473.5740214646" "20170616" "19833.0153882576" "20170622" "20543.6928661616" "20170623" "18333.13008503" "20170628" "20533.7752768777" "20170702" "21185.8099451547" "20170706" "21530.3219302399" "20170707" "21501.4540251144" "20170708" "21560.3085148359" "20170709" "21604.3494318182" "20170710" "21575.5476522735" "20170711" "21171.8373184975" "20170712" "33538.7720287593" "20170713" "38839.4998816288" "20170714" "34186.9189527107" "20170716" "30745.4312139954" "20170717" "36938.765072601" "20170718" "35555.4885179924" "20170719" "34708.6802004419" "20170721" "34117.1152146465" "20170723" "28395.5767967147" "20170729" "32483.2423453283" "20170808" "35467.440409959" "20170811" "33137.993022726" "20170813" "38347.1133083767" "20170814" "38813.8629655934" "20170815" "33236.3759864268" "20170817" "32099.0890425865" "20170819" "31925.8347292813" "20170820" "29779.050154869" "20170821" "35676.450915404" "20170822" "36065.1604719066" "20170823" "36825.3308869949" "20170825" "35603.3152225379" "20170827" "34847.1576309975" "20170828" "33909.5499921086" "20170829" "33476.2776199495" "20170907" "30022.4355690696" "20170909" "29759.3361545139" "20170910" "33545.6313311644" "20170911" "27630.5888943142" "20170912" "31284.669702395" "20170914" "30635.2254368946" "20170915" "30615.1085345336" "20170917" "33960.7116452612" "20170923" "34365.3387167574" "20170924" "32697.4608809346" "20170925" "34214.5732545178" "20170928" "35032.797945273" "20170929" "35649.4490609217" "20170930" "30783.7039519031" "20171001" "39088.1520837341" "20171003" "37746.926069934" "20171004" "38865.3320047398" "20171005" "36087.1919907079" "20171008" "48057.7670707317" "20171009" "44194.0853703046" "20171011" "26016.8502442331" "20171012" "45566.5570154672" "20171013" "43660.0595456518" "20171014" "30940.5802162247" "20171015" "39073.1213304924" "20171016" "36844.0809472595" "20171017" "46015.6005366162" "20171018" "42824.8185093427" "20171019" "34324.7006786616" "20171020" "32449.0830256915" "20171021" "29358.7568729285" "20171022" "32127.7737889145" "20171023" "38409.6600925946" "20171024" "38887.4905646738" "20171025" "42974.6162997159" "20171026" "43105.821629688" "20171027" "48047.4880865848" "20171028" "44902.1869136926" "20171029" "51976.2384663592" "20171030" "51512.8362531566" "20171031" "47008.1920784074" "20171101" "33686.63634884" "20171103" "43237.7572366734" "20171104" "39594.6658035432" "20171105" "39447.3055087003" "20171106" "49435.1889557501" "20171109" "42166.6895989312" "20171111" "47831.8918162644" "20171112" "44404.6249087555" "20171113" "48675.2537826384" "20171115" "40597.6395191231" "20171116" "30097.5650990804" "20171117" "48663.8767629296" "20171118" "41920.5491462476" "20171119" "43955.028155086" "20171120" "44897.9840394608" "20171121" "37836.30870349" "20171122" "44766.0823740333" "20171123" "49039.192347671" "20171124" "47848.1631936738" "20171125" "45709.5448341755" "20171126" "43054.0494332362" "20171127" "32418.0944947522" "20171128" "36471.0427178277" "20171129" "34010.8946693497" "20171130" "36330.9263627794" "20171201" "45610.2772056503" "20171202" "41282.6111820105" "20171203" "48081.9127217302" "20171204" "51622.3711572512" "20171205" "42460.9837715843" "20171206" "38472.454628376" "20171207" "41620.6337103025" "20171208" "49905.1557222617" "20171210" "37580.4532039141" "20171211" "46921.9022882635" "20171212" "52142.4281462082" "20171213" "44064.8756954309" "20171214" "40613.2011815851" "20171215" "39273.6874926018" "20171216" "49094.9965573706" "20171217" "50412.0520611387" "20171219" "38562.6780122699" "20171220" "31048.7068899135" "20171222" "48465.7245390921" "20171223" "37812.0250435261" "20171224" "31266.0171952681" "20171225" "33165.9374482126" "20171226" "42749.2151594066" "20171227" "38683.0726182726" "20171228" "42426.7633287834" "20171229" "41514.7415635851" "20171230" "33606.8692762587" "20171231" "34167.2374717635"} v ""))(defn enrich0toWF_ws_2953481_+0_avg1559467755356 "Enrichment - Date to WF_ws_2953481_+0_avg}" [v] (get {"20170101" "7.960282242257143" "20170102" "7.504030980214286" "20170103" "11.112997340042856" "20170104" "12.09368848772857" "20170105" "7.058665255285716" "20170106" "5.928298002328573" "20170107" "7.867270925557142" "20170108" "3.6055491447571426" "20170109" "7.649392530542857" "20170110" "7.976518874142857" "20170111" "12.6273426658" "20170112" "10.910617004428573" "20170113" "6.073336935342857" "20170114" "8.1274421083" "20170115" "5.810816546985714" "20170116" "3.9389493285142856" "20170117" "3.7400528723857143" "20170118" "7.610810600242857" "20170119" "6.671516395857142" "20170120" "5.609727018928571" "20170121" "3.177383257757143" "20170122" "3.546310383157143" "20170123" "4.065724683099999" "20170124" "4.743624117228571" "20170126" "5.81549257362857" "20170127" "6.098378736842856" "20170128" "5.7705905232142864" "20170129" "7.054108012671429" "20170130" "6.415640893942856" "20170131" "7.079313625157142" "20170201" "6.826348834085715" "20170202" "7.296419740657144" "20170203" "6.163101935685715" "20170204" "4.967120575257142" "20170205" "6.385499110057142" "20170206" "8.314685273842858" "20170207" "9.783306061542858" "20170208" "8.59343185457143" "20170209" "6.058820159814286" "20170210" "8.268389079857142" "20170211" "9.736292931542858" "20170212" "8.763563586457144" "20170214" "4.7638375094" "20170215" "4.080883741528571" "20170217" "5.1808654484000005" "20170218" "6.299972075542857" "20170219" "7.919271744585714" "20170220" "10.5822857833" "20170221" "9.602561066857144" "20170222" "12.12528784092857" "20170223" "8.145808643342857" "20170227" "8.8932739449" "20170302" "6.958342520542858" "20170304" "5.780878617457143" "20170305" "5.720669869542857" "20170306" "8.326842988485714" "20170307" "4.588275773285715" "20170310" "6.165783928285714" "20170312" "6.580898135328573" "20170315" "8.635814080228572" "20170318" "8.966973097671428" "20170319" "6.559044539571429" "20170320" "6.8700862905571425" "20170323" "4.838223971942857" "20170331" "5.946684694585714" "20170402" "4.321766652628572" "20170403" "3.501078972457143" "20170405" "8.6158685408" "20170412" "9.09943350317143" "20170415" "8.05864713772857" "20170416" "4.9757950541" "20170417" "6.902615507071429" "20170418" "6.809146530514285" "20170419" "3.155231307657143" "20170421" "9.590163613557142" "20170422" "10.488342575014286" "20170423" "8.8290028139" "20170425" "5.663214459971428" "20170426" "3.867387180271429" "20170427" "6.009825977585715" "20170429" "3.8527794133428577" "20170430" "6.985168641857142" "20170501" "10.005910557185715" "20170503" "8.792787103528571" "20170507" "4.073357030785714" "20170508" "6.7323180304" "20170510" "5.522932776371428" "20170517" "4.776165877628571" "20170522" "3.062375957271428" "20170605" "6.038844075585715" "20170606" "8.340957446171428" "20170607" "11.217317619242857" "20170612" "9.692261904328571" "20170615" "4.8412476434857155" "20170616" "8.685876823800001" "20170622" "4.982631467399999" "20170623" "6.931716166628571" "20170628" "8.523000008957144" "20170702" "8.211007447428571" "20170706" "2.6669368166714285" "20170707" "2.9330956326428574" "20170708" "5.7919057517" "20170709" "4.372688928014286" "20170710" "3.254006947842857" "20170711" "5.6597388343285715" "20170712" "6.758564852042858" "20170713" "7.2752219747" "20170714" "4.525473877642857" "20170716" "6.657471258528571" "20170717" "6.854947110771428" "20170718" "4.154022160385714" "20170719" "5.321131442457143" "20170721" "4.305398840157143" "20170723" "6.314951580699999" "20170729" "7.788948694585714" "20170808" "6.378694617114286" "20170811" "3.6687287676857143" "20170813" "6.476484335685714" "20170814" "4.508961410971429" "20170815" "6.496243789928571" "20170817" "6.464185805257143" "20170819" "8.221787849657144" "20170820" "8.873788740642857" "20170821" "7.947765115442857" "20170822" "5.517938979285715" "20170823" "3.349811901628571" "20170825" "6.2661186754714295" "20170827" "4.837923742614286" "20170828" "3.1328500612857146" "20170829" "5.484672190228571" "20170907" "6.6486640590571415" "20170909" "5.132049989742856" "20170910" "7.748140437371427" "20170911" "10.036146232214284" "20170912" "8.797732605242858" "20170914" "9.177141228300002" "20170915" "7.692439453085714" "20170917" "2.6585498351" "20170923" "3.0352980490714287" "20170924" "4.866341624928572" "20170925" "7.378102824728572" "20170928" "7.470424958814285" "20170929" "7.510946400571429" "20170930" "7.130323612457144" "20171001" "6.995843682742857" "20171003" "10.074033004371428" "20171004" "11.85806857402857" "20171005" "9.472900879085714" "20171008" "7.028792570528571" "20171009" "5.665896128314286" "20171011" "9.301944212657144" "20171012" "11.828384040357145" "20171013" "7.906651364857145" "20171014" "8.480024494" "20171015" "6.676352058757142" "20171016" "5.682936448057142" "20171017" "9.918315081157143" "20171018" "4.031174724914286" "20171019" "6.404713288542857" "20171020" "6.565938620928571" "20171021" "5.929647400514285" "20171022" "5.9085870579142865" "20171023" "4.680789105442857" "20171024" "7.7269794631714275" "20171025" "9.645387133685714" "20171026" "9.134798800657142" "20171027" "9.721746300371427" "20171028" "12.834418232328572" "20171029" "13.475399753128572" "20171030" "8.851661622585715" "20171031" "6.8190896703" "20171101" "9.238437035971428" "20171103" "6.057487382928572" "20171104" "7.435441826385714" "20171105" "6.026300063571429" "20171106" "4.884717464042858" "20171109" "7.540557382000001" "20171111" "10.292587657557144" "20171112" "6.886375980428572" "20171113" "6.189009482457144" "20171115" "4.847281980228572" "20171116" "7.539664875685714" "20171117" "8.280656387657142" "20171118" "11.701565933842858" "20171119" "11.253393541785714" "20171120" "4.8950600416571435" "20171121" "4.2178864417" "20171122" "10.017273918142857" "20171123" "11.458483824871426" "20171124" "6.394538398442857" "20171125" "5.502826930457142" "20171126" "10.006693764142858" "20171127" "10.216916117914286" "20171128" "9.16481439847143" "20171129" "3.6146631877714284" "20171130" "3.877061292914285" "20171201" "5.731221679814285" "20171202" "6.466359121028572" "20171203" "8.899172823999999" "20171204" "7.880398547671428" "20171205" "10.090446431057142" "20171206" "11.310436107628572" "20171207" "12.276863697500001" "20171208" "10.367231733485713" "20171210" "8.689328258142856" "20171211" "6.760160654171429" "20171212" "8.234119802185715" "20171213" "11.409077958714287" "20171214" "8.97040960397143" "20171215" "5.389202443900001" "20171216" "6.371156182385714" "20171217" "4.998684086871429" "20171219" "3.8010899452999993" "20171220" "5.193217941914286" "20171222" "6.987114164528571" "20171223" "11.728391303642857" "20171224" "11.830969155999998" "20171225" "11.486809519442858" "20171226" "11.556422690085714" "20171227" "7.338267931371428" "20171228" "6.742117874585714" "20171229" "8.633570150342859" "20171230" "7.7347326734571435" "20171231" "7.715646780542857"} v ""))(defn enrich0toWF_ws_2953481_+0_min1559467755357 "Enrichment - Date to WF_ws_2953481_+0_min}" [v] (get {"20170101" "5.4981951988" "20170102" "7.2480269646" "20170103" "6.6277277307" "20170104" "9.6166586646" "20170105" "4.8421104503" "20170106" "4.5504230787" "20170107" "6.3969030169" "20170108" "1.856148197" "20170109" "5.4179680249" "20170110" "7.3711771443" "20170111" "8.5119432468" "20170112" "6.8235424068" "20170113" "4.1488473945" "20170114" "6.6838079845" "20170115" "4.5839899569" "20170116" "3.2604558963" "20170117" "2.5870601244" "20170118" "6.492294165" "20170119" "5.9817948154" "20170120" "5.1218440044" "20170121" "2.3278390534" "20170122" "2.8260433274" "20170123" "2.4929824731" "20170124" "4.1559341715" "20170126" "5.2625334886" "20170127" "4.9060848008" "20170128" "4.8734045675" "20170129" "5.8980919476" "20170130" "4.4833413884" "20170131" "5.7263671655" "20170201" "5.1738670105" "20170202" "6.6751982486" "20170203" "5.4029043583" "20170204" "3.5702249988" "20170205" "3.9885059247" "20170206" "7.2584384797" "20170207" "9.007858157" "20170208" "7.4761183918" "20170209" "5.3295198389" "20170210" "6.7516249025" "20170211" "8.5739159094" "20170212" "7.4264451203" "20170214" "3.9369108789" "20170215" "3.7148906278" "20170217" "4.5835170928" "20170218" "4.541388781" "20170219" "7.0862721216" "20170220" "8.5503820082" "20170221" "8.0670077302" "20170222" "10.338038865" "20170223" "6.3642829718" "20170227" "8.3187802649" "20170302" "5.3169331515" "20170304" "5.0462498859" "20170305" "3.7112421316" "20170306" "6.4140595008" "20170307" "2.906968346" "20170310" "4.2772210491" "20170312" "5.7946854549" "20170315" "7.8022840162" "20170318" "7.0547025959" "20170319" "5.1631866689" "20170320" "4.4267568395" "20170323" "3.7742225404" "20170331" "5.3546595514" "20170402" "2.9223799759" "20170403" "2.7323349226" "20170405" "4.5435867918" "20170412" "8.8022577824" "20170415" "4.4853708263" "20170416" "2.9110073773" "20170417" "5.4648642763" "20170418" "5.2178408191" "20170419" "2.3394887178" "20170421" "7.7410438918" "20170422" "9.346329806" "20170423" "7.6596508371" "20170425" "4.016898626" "20170426" "2.9447277023" "20170427" "4.5910727204" "20170429" "2.9026887296" "20170430" "4.1554654653" "20170501" "9.3874765144" "20170503" "8.3953058458" "20170507" "3.2879646457" "20170508" "4.5783634937" "20170510" "4.1982509989" "20170517" "2.9004238284" "20170522" "2.3679901076" "20170605" "4.7713214928" "20170606" "6.5919245401" "20170607" "9.0090573736" "20170612" "7.1212395682" "20170615" "3.3282448126" "20170616" "6.8644487209" "20170622" "4.026843858" "20170623" "6.0265669359" "20170628" "4.345672401" "20170702" "6.5476175896" "20170706" "1.8096173377" "20170707" "2.1655142067" "20170708" "4.0879148531" "20170709" "3.4406753834" "20170710" "2.451482531" "20170711" "4.4534857209" "20170712" "5.3146864818" "20170713" "5.5307016245" "20170714" "2.6439958226" "20170716" "5.6183421713" "20170717" "5.9072667233" "20170718" "3.2910299613" "20170719" "3.6099314845" "20170721" "3.4454292315" "20170723" "4.1525793537" "20170729" "5.0057096918" "20170808" "3.3371864803" "20170811" "2.8715129624" "20170813" "3.9134015712" "20170814" "3.3368743103" "20170815" "5.7492612363" "20170817" "4.5234508643" "20170819" "6.2219666509" "20170820" "8.5003856199" "20170821" "7.1090651012" "20170822" "3.5786287472" "20170823" "2.5422262032" "20170825" "3.7786279313" "20170827" "3.7410443627" "20170828" "2.3604781032" "20170829" "4.9340438377" "20170907" "5.3042100832" "20170909" "3.4040490186" "20170910" "5.7140077992" "20170911" "9.3926881789" "20170912" "8.3749408001" "20170914" "7.9345088029" "20170915" "5.8205096646" "20170917" "2.3979447257" "20170923" "2.6546209552" "20170924" "3.3365067663" "20170925" "6.5975605899" "20170928" "6.6471847127" "20170929" "6.4376776038" "20170930" "6.2708355171" "20171001" "5.8913505176" "20171003" "8.7393037424" "20171004" "10.2976116425" "20171005" "7.0825011813" "20171008" "6.0651395691" "20171009" "4.6437750252" "20171011" "6.9887887317" "20171012" "9.4289766758" "20171013" "6.6829346921" "20171014" "7.4503910204" "20171015" "5.8623515348" "20171016" "4.9925890917" "20171017" "7.7176292211" "20171018" "1.6380021211" "20171019" "3.8465316328" "20171020" "5.2272439" "20171021" "4.3674745087" "20171022" "3.445582061" "20171023" "3.1861824379" "20171024" "6.1474099868" "20171025" "7.7227620299" "20171026" "8.2239127964" "20171027" "8.7464253482" "20171028" "11.1685061256" "20171029" "11.7120403935" "20171030" "6.9765022773" "20171031" "6.0217004973" "20171101" "7.6650180525" "20171103" "4.2126726168" "20171104" "6.8624712846" "20171105" "5.1539753606" "20171106" "3.8725178315" "20171109" "3.5488802598" "20171111" "9.5023310523" "20171112" "5.4545120374" "20171113" "5.3261117408" "20171115" "3.1377793934" "20171116" "3.8182943292" "20171117" "7.6869759876" "20171118" "10.5013830967" "20171119" "9.2235457552" "20171120" "2.7314432357" "20171121" "2.5929610027" "20171122" "8.6510667125" "20171123" "10.1283313092" "20171124" "4.7730801135" "20171125" "4.7454369406" "20171126" "8.0904309317" "20171127" "9.2233835108" "20171128" "6.6084087442" "20171129" "2.6737754732" "20171130" "3.1989168748" "20171201" "3.7714385739" "20171202" "3.0629782525" "20171203" "8.4113114958" "20171204" "6.6487020912" "20171205" "7.7100164987" "20171206" "10.9026389897" "20171207" "10.490345105" "20171208" "9.6606759425" "20171210" "7.7855008344" "20171211" "5.300683277" "20171212" "7.0583576438" "20171213" "10.3995188469" "20171214" "7.137110636" "20171215" "4.0571235971" "20171216" "6.0037645659" "20171217" "3.0933206602" "20171219" "2.5075911356" "20171220" "2.5098299719" "20171222" "6.5374041644" "20171223" "9.3369736756" "20171224" "10.0511289007" "20171225" "11.0122417442" "20171226" "10.3286041975" "20171227" "6.4876699742" "20171228" "5.7139662364" "20171229" "8.2381636021" "20171230" "6.5271642167" "20171231" "5.4940113612"} v ""))(defn enrich0toWF_ws_2953481_+0_max1559467755357 "Enrichment - Date to WF_ws_2953481_+0_max}" [v] (get {"20170101" "10.4487779573" "20170102" "8.0618425126" "20170103" "13.485656295" "20170104" "14.7868767452" "20170105" "8.7296188893" "20170106" "8.5354697014" "20170107" "9.2341924895" "20170108" "5.5678759418" "20170109" "9.0393411703" "20170110" "9.5022944918" "20170111" "14.2276101416" "20170112" "12.6641857273" "20170113" "8.9100694219" "20170114" "8.7562457589" "20170115" "7.2592086271" "20170116" "4.5048605158" "20170117" "5.6932471939" "20170118" "8.0496020317" "20170119" "7.1878810361" "20170120" "6.2658734866" "20170121" "4.1952582503" "20170122" "4.5559238574" "20170123" "4.6172250369" "20170124" "5.3855192059" "20170126" "6.1438654544" "20170127" "7.2169548175" "20170128" "6.4058881898" "20170129" "7.4323263026" "20170130" "8.2380731618" "20170131" "8.2419540084" "20170201" "8.3519421836" "20170202" "8.2650891638" "20170203" "7.207946662" "20170204" "6.3654873759" "20170205" "7.3351599932" "20170206" "9.0541623175" "20170207" "10.6559643465" "20170208" "9.8200181891" "20170209" "6.7430048261" "20170210" "9.3603593698" "20170211" "10.8082528978" "20170212" "9.5710457062" "20170214" "5.503240822" "20170215" "5.1164584763" "20170217" "7.0353423869" "20170218" "8.7423516439" "20170219" "8.9350449895" "20170220" "11.3769306669" "20170221" "10.645385786" "20170222" "14.3896169735" "20170223" "13.7537894392" "20170227" "9.8093022625" "20170302" "8.602592508" "20170304" "6.2306276998" "20170305" "7.2759305986" "20170306" "9.3418381456" "20170307" "7.4654315268" "20170310" "8.0442516093" "20170312" "6.8988959854" "20170315" "9.6043498877" "20170318" "9.8973395799" "20170319" "7.9028321647" "20170320" "9.8365543718" "20170323" "5.4616567529" "20170331" "6.2543873429" "20170402" "5.2312402311" "20170403" "4.3832183823" "20170405" "11.4864523162" "20170412" "9.2860438557" "20170415" "10.1425895502" "20170416" "7.7059986208" "20170417" "8.2334241957" "20170418" "8.4101721089" "20170419" "4.5304847905" "20170421" "11.6175325203" "20170422" "11.2610512363" "20170423" "9.6449480659" "20170425" "7.4584498252" "20170426" "4.8771969323" "20170427" "7.3914241624" "20170429" "5.05518276" "20170430" "9.3474425" "20170501" "10.4479107079" "20170503" "9.015245366" "20170507" "4.9274534567" "20170508" "8.8680478297" "20170510" "6.5648448611" "20170517" "7.4231156283" "20170522" "3.9664777235" "20170605" "6.8209951775" "20170606" "9.2688546871" "20170607" "12.9717904973" "20170612" "10.8323410703" "20170615" "6.2105260073" "20170616" "9.2926325154" "20170622" "6.2279203146" "20170623" "7.9465440801" "20170628" "10.5584586083" "20170702" "9.0614598512" "20170706" "3.4753757106" "20170707" "3.6682243537" "20170708" "6.8055075954" "20170709" "4.9789680439" "20170710" "3.6520647407" "20170711" "6.6703424587" "20170712" "9.2218251884" "20170713" "9.3961510699" "20170714" "5.6169537222" "20170716" "7.3723634953" "20170717" "7.7083443063" "20170718" "5.5782578495" "20170719" "7.23277753" "20170721" "5.2863660164" "20170723" "7.4963308584" "20170729" "9.3061471353" "20170808" "8.0402865845" "20170811" "4.4124682757" "20170813" "7.8076891059" "20170814" "6.2687573904" "20170815" "6.8893749214" "20170817" "7.4530427093" "20170819" "9.2444535904" "20170820" "9.3484972056" "20170821" "8.4715955279" "20170822" "7.1763871729" "20170823" "4.3004977552" "20170825" "7.539403545" "20170827" "5.7847945273" "20170828" "3.8271733113" "20170829" "6.0834602738" "20170907" "8.1762390894" "20170909" "6.8310619457" "20170910" "9.4830405955" "20170911" "11.1005067938" "20170912" "9.3523404617" "20170914" "13.4529768878" "20170915" "8.6476512128" "20170917" "2.9926616239" "20170923" "3.8701106084" "20170924" "6.464199456" "20170925" "7.9098931913" "20170928" "8.5104505455" "20170929" "8.5750087002" "20170930" "7.9529517507" "20171001" "8.8583390129" "20171003" "10.9688247043" "20171004" "13.0352066367" "20171005" "11.0942312316" "20171008" "7.7547726606" "20171009" "6.5271963891" "20171011" "11.14368258" "20171012" "13.0520442361" "20171013" "8.5919200458" "20171014" "8.96182376" "20171015" "7.4547135562" "20171016" "6.9434589681" "20171017" "11.0411716122" "20171018" "8.529191254" "20171019" "7.4903515762" "20171020" "7.4623353969" "20171021" "7.3213266622" "20171022" "7.8417281234" "20171023" "5.8696468852" "20171024" "8.697775774" "20171025" "11.0577862253" "20171026" "10.1053095991" "20171027" "10.3057794706" "20171028" "13.7046375684" "20171029" "16.1571032183" "20171030" "10.7598114203" "20171031" "7.1848165556" "20171101" "11.2134263287" "20171103" "7.938664256" "20171104" "7.9193929976" "20171105" "7.5505290577" "20171106" "5.5780904513" "20171109" "9.3442009262" "20171111" "12.2511135202" "20171112" "10.0310927639" "20171113" "6.8412424879" "20171115" "6.2181808975" "20171116" "9.6263197498" "20171117" "9.4330124873" "20171118" "12.4636463543" "20171119" "12.5911054345" "20171120" "8.5369768454" "20171121" "7.6149382814" "20171122" "10.8380230637" "20171123" "12.4490270555" "20171124" "9.5372479087" "20171125" "6.5010788555" "20171126" "10.8395988927" "20171127" "11.0290851378" "20171128" "11.0079380088" "20171129" "4.3512811339" "20171130" "5.7562467398" "20171201" "6.5980624967" "20171202" "8.6515436678" "20171203" "9.3695593112" "20171204" "9.0251435775" "20171205" "11.2100635441" "20171206" "11.8060105006" "20171207" "13.4716059705" "20171208" "11.6966579975" "20171210" "9.2387168223" "20171211" "8.2186762397" "20171212" "9.4721270604" "20171213" "12.3994174442" "20171214" "10.0061783195" "20171215" "7.6823432104" "20171216" "6.5713269674" "20171217" "7.166339464" "20171219" "5.371311172" "20171220" "6.7480301927" "20171222" "7.3728452529" "20171223" "12.9713033897" "20171224" "12.9928933057" "20171225" "12.0492823099" "20171226" "12.5049809294" "20171227" "8.9700877365" "20171228" "9.0210094189" "20171229" "9.4759920635" "20171230" "8.7554503642" "20171231" "9.9070467069"} v ""))(def make-graph (graph-fn [{:keys [geoId geoId_parentADM1 WF_2d_2953481_+0_avg WF_2d_2953481_+0_min WF_2d_2953481_+0_max WF_2t_2953481_+0_avg WF_2t_2953481_+0_min WF_2t_2953481_+0_max WF_rh_2953481_+0_avg WF_rh_2953481_+0_min WF_rh_2953481_+0_max WF_sd_2953481_+0_avg WF_sd_2953481_+0_min WF_sd_2953481_+0_max WF_sp_2953481_+0_avg WF_sp_2953481_+0_min WF_sp_2953481_+0_max WF_ssr_2953481_+0_cumul WF_tcc_2953481_+0_avg WF_tcc_2953481_+0_min WF_tcc_2953481_+0_max WF_tp_2953481_+0_cumul WF_vis_2953481_+0_avg WF_vis_2953481_+0_min WF_vis_2953481_+0_max WF_ws_2953481_+0_avg WF_ws_2953481_+0_min WF_ws_2953481_+0_max]}] (graph "http://example.com/") (graph "http://example.com/")))(defpipe my-pipe "Grafter pipeline for data clean-up and preparation." [data-file] (-> (read-dataset data-file) (-> (make-dataset move-first-row-to-header) (rename-columns (comp keyword new-tabular/string-as-keyword))) (derive-column :geoId [:StrCity] enrich3togeoId1559467591747) (new-tabular/shift-column :geoId 4) (derive-column :geoId_parentADM1 [:geoId] enrich4togeoId_parentADM11559467615152) (new-tabular/shift-column :geoId_parentADM1 5) (grep "2952" [:CategoryGERId]) (grep "2953481" [:geoId_parentADM1]) (new-tabular/group-rows [:Date :CategoryGERId :geoId_parentADM1] #{{:Impressions "SUM"}}) (derive-column :WF_2d_2953481_+0_avg [:Date] enrich0toWF_2d_2953481_+0_avg1559467755354) (derive-column :WF_2d_2953481_+0_min [:Date] enrich0toWF_2d_2953481_+0_min1559467755354) (derive-column :WF_2d_2953481_+0_max [:Date] enrich0toWF_2d_2953481_+0_max1559467755354) (derive-column :WF_2t_2953481_+0_avg [:Date] enrich0toWF_2t_2953481_+0_avg1559467755354) (derive-column :WF_2t_2953481_+0_min [:Date] enrich0toWF_2t_2953481_+0_min1559467755355) (derive-column :WF_2t_2953481_+0_max [:Date] enrich0toWF_2t_2953481_+0_max1559467755355) (derive-column :WF_rh_2953481_+0_avg [:Date] enrich0toWF_rh_2953481_+0_avg1559467755355) (derive-column :WF_rh_2953481_+0_min [:Date] enrich0toWF_rh_2953481_+0_min1559467755355) (derive-column :WF_rh_2953481_+0_max [:Date] enrich0toWF_rh_2953481_+0_max1559467755355) (derive-column :WF_sd_2953481_+0_avg [:Date] enrich0toWF_sd_2953481_+0_avg1559467755355) (derive-column :WF_sd_2953481_+0_min [:Date] enrich0toWF_sd_2953481_+0_min1559467755355) (derive-column :WF_sd_2953481_+0_max [:Date] enrich0toWF_sd_2953481_+0_max1559467755355) (derive-column :WF_sp_2953481_+0_avg [:Date] enrich0toWF_sp_2953481_+0_avg1559467755355) (derive-column :WF_sp_2953481_+0_min [:Date] enrich0toWF_sp_2953481_+0_min1559467755355) (derive-column :WF_sp_2953481_+0_max [:Date] enrich0toWF_sp_2953481_+0_max1559467755355) (derive-column :WF_ssr_2953481_+0_cumul [:Date] enrich0toWF_ssr_2953481_+0_cumul1559467755356) (derive-column :WF_tcc_2953481_+0_avg [:Date] enrich0toWF_tcc_2953481_+0_avg1559467755356) (derive-column :WF_tcc_2953481_+0_min [:Date] enrich0toWF_tcc_2953481_+0_min1559467755356) (derive-column :WF_tcc_2953481_+0_max [:Date] enrich0toWF_tcc_2953481_+0_max1559467755356) (derive-column :WF_tp_2953481_+0_cumul [:Date] enrich0toWF_tp_2953481_+0_cumul1559467755356) (derive-column :WF_vis_2953481_+0_avg [:Date] enrich0toWF_vis_2953481_+0_avg1559467755356) (derive-column :WF_vis_2953481_+0_min [:Date] enrich0toWF_vis_2953481_+0_min1559467755356) (derive-column :WF_vis_2953481_+0_max [:Date] enrich0toWF_vis_2953481_+0_max1559467755356) (derive-column :WF_ws_2953481_+0_avg [:Date] enrich0toWF_ws_2953481_+0_avg1559467755356) (derive-column :WF_ws_2953481_+0_min [:Date] enrich0toWF_ws_2953481_+0_min1559467755357) (derive-column :WF_ws_2953481_+0_max [:Date] enrich0toWF_ws_2953481_+0_max1559467755357)))(defgraft my-graft "Transformation that converts input CSV data into RDF graph data." my-pipe make-graph)(defn import-data  [pipe-result destination]  (write-dataset destination pipe-result))(defn my-transformation [dataset output]  (import-data    (my-pipe dataset)  output))